{"openapi":"3.1.0","info":{"title":"Castle API","description":"HTTP API for Hyperbolic's on-demand GPU compute: rent virtual machines and bare-metal instances, manage storage volumes, and track usage and billing. Authenticate with a Bearer API key (`Authorization: Bearer <api-key>`).","version":"2.0.0","contact":{"name":"Hyperbolic","url":"https://hyperbolic.ai"}},"servers":[{"url":"https://api.hyperbolic.ai","description":"Production"}],"paths":{"/v2/openapi.json":{"get":{"operationId":"openApiJson","security":[{"Authorization":[]}],"parameters":[],"responses":{"200":{"description":"Successful response","content":{"application/json":{"schema":{}}}},"400":{"description":"Invalid input data","content":{"application/json":{"schema":{"$ref":"#/components/schemas/error.BAD_REQUEST"}}}},"401":{"description":"Authorization not provided","content":{"application/json":{"schema":{"$ref":"#/components/schemas/error.UNAUTHORIZED"}}}},"403":{"description":"Insufficient access","content":{"application/json":{"schema":{"$ref":"#/components/schemas/error.FORBIDDEN"}}}},"404":{"description":"Not found","content":{"application/json":{"schema":{"$ref":"#/components/schemas/error.NOT_FOUND"}}}},"500":{"description":"Internal server error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/error.INTERNAL_SERVER_ERROR"}}}}}}},"/v2/usage/request-cost":{"post":{"operationId":"usage-getRequestCost","summary":"Provides the inference request cost in nanoUSD for a list of request IDs.","description":"Inference requests are billed based on the cost of the tokens used in the request.  The request ID can be found in the \"X-Inference-Request-Id\" inference response header.","security":[{"Authorization":[]}],"parameters":[],"requestBody":{"required":true,"content":{"application/json":{"schema":{"type":"object","properties":{"requestIds":{"maxItems":100,"type":"array","items":{"type":"string"}}},"required":["requestIds"]}}}},"responses":{"200":{"description":"Successful response","content":{"application/json":{"schema":{"type":"object","properties":{"requests":{"maxItems":100,"type":"array","items":{"type":"object","properties":{"requestId":{"type":"string"},"costNanoUsd":{"type":"number"}},"required":["requestId","costNanoUsd"],"additionalProperties":false}}},"required":["requests"],"additionalProperties":false}}}},"400":{"description":"Invalid input data","content":{"application/json":{"schema":{"$ref":"#/components/schemas/error.BAD_REQUEST"}}}},"401":{"description":"Authorization not provided","content":{"application/json":{"schema":{"$ref":"#/components/schemas/error.UNAUTHORIZED"}}}},"403":{"description":"Insufficient access","content":{"application/json":{"schema":{"$ref":"#/components/schemas/error.FORBIDDEN"}}}},"500":{"description":"Internal server error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/error.INTERNAL_SERVER_ERROR"}}}}}}},"/v2/alpha/on-demand/storage-volumes/attach":{"post":{"operationId":"ondemand-attachStorageVolume","summary":"Attach a storage volume to bare metal instance(s)","description":"Attach a storage volume to bare metal instance(s)","security":[{"Authorization":[]}],"parameters":[],"requestBody":{"required":true,"content":{"application/json":{"schema":{"type":"object","properties":{"storageVolumeId":{"type":"integer","exclusiveMinimum":0,"maximum":9007199254740991},"rentalIds":{"minItems":1,"type":"array","items":{"type":"integer","minimum":-9007199254740991,"maximum":9007199254740991}}},"required":["storageVolumeId","rentalIds"]}}}},"responses":{"200":{"description":"Successful response","content":{"application/json":{"schema":{"type":"object","properties":{"storageVolumeId":{"type":"integer","exclusiveMinimum":0,"maximum":9007199254740991},"attachedRentalIds":{"type":"array","items":{"type":"integer","exclusiveMinimum":0,"maximum":9007199254740991}},"message":{"type":"string"}},"required":["storageVolumeId","attachedRentalIds","message"],"additionalProperties":false}}}},"400":{"description":"Invalid input data","content":{"application/json":{"schema":{"$ref":"#/components/schemas/error.BAD_REQUEST"}}}},"401":{"description":"Authorization not provided","content":{"application/json":{"schema":{"$ref":"#/components/schemas/error.UNAUTHORIZED"}}}},"403":{"description":"Insufficient access","content":{"application/json":{"schema":{"$ref":"#/components/schemas/error.FORBIDDEN"}}}},"500":{"description":"Internal server error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/error.INTERNAL_SERVER_ERROR"}}}}}}},"/v2/alpha/on-demand/bare-metal-rentals":{"post":{"operationId":"ondemand-createBareMetalRental","summary":"Create a bare metal rental","description":"Create a bare metal rental","security":[{"Authorization":[]}],"parameters":[],"requestBody":{"required":true,"content":{"application/json":{"schema":{"type":"object","properties":{"networkType":{"type":"string","enum":["infiniband","ethernet"]},"gpuCount":{"type":"number","minimum":1,"multipleOf":8},"storageVolume":{"oneOf":[{"type":"object","properties":{"isNew":{"type":"boolean","const":false},"id":{"type":"integer","exclusiveMinimum":0,"maximum":9007199254740991}},"required":["isNew","id"]},{"type":"object","properties":{"isNew":{"type":"boolean","const":true},"label":{"type":"string","minLength":4,"maxLength":255,"pattern":"^[a-zA-Z0-9_-]+$"},"sizeInGb":{"type":"integer","minimum":256,"maximum":64000}},"required":["isNew","label","sizeInGb"]}],"type":"object"},"region":{"default":"us-central-1","type":"string","enum":["us-central-1","uk-central-3","uk-southeast-3","eu-southwest-3","eu-southwest-3-1","eu-west-3","eu-west-4"]},"gpuType":{"default":"h100","type":"string","enum":["h100","h200","b200"]},"cudaVersion":{"type":"string","enum":["cuda12.8","cuda12.9"]},"label":{"type":"string"},"termType":{"default":"on-demand","type":"string","enum":["on-demand","reserved"]},"discountPercentage":{"default":0,"type":"number"},"termPeriodDays":{"type":"number"},"monitoringEnabled":{"type":"boolean"},"convertToOnDemandOnExpiry":{"default":true,"type":"boolean"}},"required":["networkType","gpuCount"]}}}},"responses":{"200":{"description":"Successful response","content":{"application/json":{"schema":{"type":"object","properties":{"id":{"type":"integer","minimum":-2147483648,"maximum":2147483647},"createdAt":{"type":"string"},"updatedAt":{"anyOf":[{"type":"string"},{"type":"null"}]},"deletedAt":{"anyOf":[{"type":"string"},{"type":"null"}]},"userId":{"type":"string","maxLength":50},"orgId":{"anyOf":[{},{"type":"null"}]},"startedAt":{"anyOf":[{"type":"string"},{"type":"null"}]},"terminatedAt":{"anyOf":[{"type":"string"},{"type":"null"}]},"externalId":{"type":"string"},"rentalId":{},"providerData":{"oneOf":[{"type":"object","properties":{"externalId":{"type":"string"},"sshNetworking":{"type":"array","items":{"type":"object","properties":{"host":{"type":"string"},"port":{"type":"number"},"user":{"type":"string"}},"required":["host","port","user"],"additionalProperties":false}},"nodeNetworking":{"type":"array","items":{"type":"object","properties":{"publicIp":{"type":"string"},"privateIp":{"type":"string"}},"required":["publicIp","privateIp"],"additionalProperties":false}},"networkType":{"type":"string","enum":["infiniband","ethernet"]},"gpuFormFactor":{"type":"string","enum":["sxm5","sxm6","pcie"]},"providerId":{"type":"string","const":"nebius"},"resources":{"type":"object","properties":{"cpuModel":{"type":"string"},"gpuCount":{"type":"number"},"ramGb":{"type":"number"},"storageGb":{"type":"number"},"vcpuCount":{"type":"number"}},"required":["cpuModel","gpuCount","ramGb","storageGb","vcpuCount"],"additionalProperties":false}},"required":["providerId","resources"],"additionalProperties":false},{"type":"object","properties":{"externalId":{"type":"string"},"sshNetworking":{"type":"array","items":{"type":"object","properties":{"host":{"type":"string"},"port":{"type":"number"},"user":{"type":"string"}},"required":["host","port","user"],"additionalProperties":false}},"nodeNetworking":{"type":"array","items":{"type":"object","properties":{"publicIp":{"type":"string"},"privateIp":{"type":"string"}},"required":["publicIp","privateIp"],"additionalProperties":false}},"networkType":{"type":"string","enum":["infiniband","ethernet"]},"gpuFormFactor":{"type":"string","enum":["sxm5","sxm6","pcie"]},"providerId":{"type":"string","const":"voltage-park"},"resources":{"anyOf":[{"type":"object","properties":{"cpuModel":{"type":"string"},"gpuCount":{"type":"number"},"ramGb":{"type":"number"},"storageGb":{"type":"number"},"cpuCount":{"type":"number"}},"required":["cpuModel","gpuCount","ramGb","storageGb","cpuCount"],"additionalProperties":false},{"type":"object","properties":{"cpuModel":{"type":"string"},"gpuCount":{"type":"number"},"ramGb":{"type":"number"},"storageGb":{"type":"number"},"vcpuCount":{"type":"number"}},"required":["cpuModel","gpuCount","ramGb","storageGb","vcpuCount"],"additionalProperties":false}]},"subOrder":{"type":"string"},"portForwards":{"type":"array","items":{"type":"object","properties":{"externalPort":{"type":"number"},"internalPort":{"type":"number"}},"required":["externalPort","internalPort"],"additionalProperties":false}}},"required":["networkType","providerId","resources"],"additionalProperties":false},{"type":"object","properties":{"externalId":{"type":"string"},"sshNetworking":{"type":"array","items":{"type":"object","properties":{"host":{"type":"string"},"port":{"type":"number"},"user":{"type":"string"}},"required":["host","port","user"],"additionalProperties":false}},"nodeNetworking":{"type":"array","items":{"type":"object","properties":{"publicIp":{"type":"string"},"privateIp":{"type":"string"}},"required":["publicIp","privateIp"],"additionalProperties":false}},"networkType":{"type":"string","enum":["infiniband","ethernet"]},"gpuFormFactor":{"type":"string","enum":["sxm5","sxm6","pcie"]},"providerId":{"type":"string","const":"gcore"},"resources":{"type":"object","properties":{"cpuModel":{"type":"string"},"gpuCount":{"type":"number"},"ramGb":{"type":"number"},"storageGb":{"type":"number"},"cpuCount":{"type":"number"}},"required":["cpuModel","gpuCount","ramGb","storageGb","cpuCount"],"additionalProperties":false}},"required":["providerId","resources"],"additionalProperties":false},{"type":"object","properties":{"externalId":{"type":"string"},"sshNetworking":{"type":"array","items":{"type":"object","properties":{"host":{"type":"string"},"port":{"type":"number"},"user":{"type":"string"}},"required":["host","port","user"],"additionalProperties":false}},"nodeNetworking":{"type":"array","items":{"type":"object","properties":{"publicIp":{"type":"string"},"privateIp":{"type":"string"}},"required":["publicIp","privateIp"],"additionalProperties":false}},"networkType":{"type":"string","enum":["infiniband","ethernet"]},"gpuFormFactor":{"type":"string","enum":["sxm5","sxm6","pcie"]},"providerId":{"type":"string","const":"horizon"},"publicIpAddressId":{"type":"string"},"resources":{"type":"object","properties":{"cpuModel":{"type":"string"},"gpuCount":{"type":"number"},"ramGb":{"type":"number"},"storageGb":{"type":"number"},"vcpuCount":{"type":"number"}},"required":["cpuModel","gpuCount","ramGb","storageGb","vcpuCount"],"additionalProperties":false}},"required":["providerId","resources"],"additionalProperties":false},{"type":"object","properties":{"externalId":{"type":"string"},"sshNetworking":{"type":"array","items":{"type":"object","properties":{"host":{"type":"string"},"port":{"type":"number"},"user":{"type":"string"}},"required":["host","port","user"],"additionalProperties":false}},"nodeNetworking":{"type":"array","items":{"type":"object","properties":{"publicIp":{"type":"string"},"privateIp":{"type":"string"}},"required":["publicIp","privateIp"],"additionalProperties":false}},"networkType":{"type":"string","enum":["infiniband","ethernet"]},"gpuFormFactor":{"type":"string","enum":["sxm5","sxm6","pcie"]},"providerId":{"type":"string","const":"digital-ocean"},"resources":{"type":"object","properties":{"cpuModel":{"type":"string"},"gpuCount":{"type":"number"},"ramGb":{"type":"number"},"storageGb":{"type":"number"},"vcpuCount":{"type":"number"}},"required":["cpuModel","gpuCount","ramGb","storageGb","vcpuCount"],"additionalProperties":false},"poolType":{"anyOf":[{"type":"string","enum":["public","contracted"]},{"type":"null"}]}},"required":["providerId","resources"],"additionalProperties":false},{"type":"object","properties":{"externalId":{"type":"string"},"sshNetworking":{"type":"array","items":{"type":"object","properties":{"host":{"type":"string"},"port":{"type":"number"},"user":{"type":"string"}},"required":["host","port","user"],"additionalProperties":false}},"nodeNetworking":{"type":"array","items":{"type":"object","properties":{"publicIp":{"type":"string"},"privateIp":{"type":"string"}},"required":["publicIp","privateIp"],"additionalProperties":false}},"networkType":{"type":"string","enum":["infiniband","ethernet"]},"gpuFormFactor":{"type":"string","enum":["sxm5","sxm6","pcie"]},"providerId":{"type":"string","const":"verda"},"resources":{"type":"object","properties":{"cpuModel":{"type":"string"},"gpuCount":{"type":"number"},"ramGb":{"type":"number"},"storageGb":{"type":"number"},"vcpuCount":{"type":"number"}},"required":["cpuModel","gpuCount","ramGb","storageGb","vcpuCount"],"additionalProperties":false}},"required":["providerId","resources"],"additionalProperties":false},{"type":"object","properties":{"externalId":{"type":"string"},"sshNetworking":{"type":"array","items":{"type":"object","properties":{"host":{"type":"string"},"port":{"type":"number"},"user":{"type":"string"}},"required":["host","port","user"],"additionalProperties":false}},"nodeNetworking":{"type":"array","items":{"type":"object","properties":{"publicIp":{"type":"string"},"privateIp":{"type":"string"}},"required":["publicIp","privateIp"],"additionalProperties":false}},"networkType":{"type":"string","enum":["infiniband","ethernet"]},"gpuFormFactor":{"type":"string","enum":["sxm5","sxm6","pcie"]},"providerId":{"type":"string","const":"hyperstack"},"resources":{"type":"object","properties":{"cpuModel":{"type":"string"},"gpuCount":{"type":"number"},"ramGb":{"type":"number"},"storageGb":{"type":"number"},"vcpuCount":{"type":"number"}},"required":["cpuModel","gpuCount","ramGb","storageGb","vcpuCount"],"additionalProperties":false}},"required":["providerId","resources"],"additionalProperties":false},{"type":"object","properties":{"externalId":{"type":"string"},"sshNetworking":{"type":"array","items":{"type":"object","properties":{"host":{"type":"string"},"port":{"type":"number"},"user":{"type":"string"}},"required":["host","port","user"],"additionalProperties":false}},"nodeNetworking":{"type":"array","items":{"type":"object","properties":{"publicIp":{"type":"string"},"privateIp":{"type":"string"}},"required":["publicIp","privateIp"],"additionalProperties":false}},"networkType":{"type":"string","enum":["infiniband","ethernet"]},"gpuFormFactor":{"type":"string","enum":["sxm5","sxm6","pcie"]},"providerId":{"type":"string","const":"forge"},"resources":{"anyOf":[{"type":"object","properties":{"cpuModel":{"type":"string"},"gpuCount":{"type":"number"},"ramGb":{"type":"number"},"storageGb":{"type":"number"},"cpuCount":{"type":"number"}},"required":["cpuModel","gpuCount","ramGb","storageGb","cpuCount"],"additionalProperties":false},{"type":"object","properties":{"cpuModel":{"type":"string"},"gpuCount":{"type":"number"},"ramGb":{"type":"number"},"storageGb":{"type":"number"},"vcpuCount":{"type":"number"}},"required":["cpuModel","gpuCount","ramGb","storageGb","vcpuCount"],"additionalProperties":false}]},"customPorts":{"maxItems":20,"type":"array","items":{"type":"integer","minimum":1,"maximum":65535}}},"required":["providerId","resources"],"additionalProperties":false},{"type":"object","properties":{"externalId":{"type":"string"},"sshNetworking":{"type":"array","items":{"type":"object","properties":{"host":{"type":"string"},"port":{"type":"number"},"user":{"type":"string"}},"required":["host","port","user"],"additionalProperties":false}},"nodeNetworking":{"type":"array","items":{"type":"object","properties":{"publicIp":{"type":"string"},"privateIp":{"type":"string"}},"required":["publicIp","privateIp"],"additionalProperties":false}},"networkType":{"type":"string","enum":["infiniband","ethernet"]},"gpuFormFactor":{"type":"string","enum":["sxm5","sxm6","pcie"]},"providerId":{"type":"string","const":"private-cloud"},"gpuModel":{"type":"string"},"location":{"type":"string"},"benchmark":{"type":"object","propertyNames":{"type":"string"},"additionalProperties":{}},"resources":{"anyOf":[{"type":"object","properties":{"cpuModel":{"type":"string"},"gpuCount":{"type":"number"},"ramGb":{"type":"number"},"storageGb":{"type":"number"},"cpuCount":{"type":"number"}},"required":["cpuModel","gpuCount","ramGb","storageGb","cpuCount"],"additionalProperties":false},{"type":"object","properties":{"cpuModel":{"type":"string"},"gpuCount":{"type":"number"},"ramGb":{"type":"number"},"storageGb":{"type":"number"},"vcpuCount":{"type":"number"}},"required":["cpuModel","gpuCount","ramGb","storageGb","vcpuCount"],"additionalProperties":false}]},"nodes":{"type":"array","items":{"type":"object","properties":{"role":{"default":"compute","type":"string","enum":["login","head","compute"]},"hostname":{"type":"string"},"publicIp":{"type":"string"},"privateIp":{"type":"string"}},"required":["role","privateIp"],"additionalProperties":false}},"sshUser":{"type":"string"},"sshPort":{"type":"number"},"extra":{"type":"object","propertyNames":{"type":"string"},"additionalProperties":{}}},"required":["providerId","resources","nodes","sshUser"],"additionalProperties":false},{"type":"object","properties":{"externalId":{"type":"string"},"sshNetworking":{"type":"array","items":{"type":"object","properties":{"host":{"type":"string"},"port":{"type":"number"},"user":{"type":"string"}},"required":["host","port","user"],"additionalProperties":false}},"nodeNetworking":{"type":"array","items":{"type":"object","properties":{"publicIp":{"type":"string"},"privateIp":{"type":"string"}},"required":["publicIp","privateIp"],"additionalProperties":false}},"networkType":{"type":"string","enum":["infiniband","ethernet"]},"gpuFormFactor":{"type":"string","enum":["sxm5","sxm6","pcie"]},"providerId":{"type":"string","const":"mock"},"resources":{"type":"object","properties":{"cpuModel":{"type":"string"},"gpuCount":{"type":"number"},"ramGb":{"type":"number"},"storageGb":{"type":"number"},"vcpuCount":{"type":"number"}},"required":["cpuModel","gpuCount","ramGb","storageGb","vcpuCount"],"additionalProperties":false},"customPorts":{"maxItems":20,"type":"array","items":{"type":"integer","minimum":1,"maximum":65535}}},"required":["providerId","resources"],"additionalProperties":false}],"type":"object"},"rentalType":{"type":"string","enum":["virtual-machine","bare-metal"]},"name":{"anyOf":[{"type":"string"},{"type":"null"}]},"label":{"anyOf":[{"type":"string"},{"type":"null"}]},"region":{"anyOf":[{"type":"string","enum":["us-central-1","us-central-2","eu-north-2","eu-west-2","eu-north-4","eu-north-5","us-east-1","us-east-2","ca-east-3","eu-north-6","eu-north-7","eu-north-8","ca-west-1","ca-east-1","us-central-3","us-southeast-1","me-central-1","ca-east-2","eu-west-1","us-southeast-2","jp-east-1","mock-region","uk-central-3","uk-southeast-3","eu-southwest-3","eu-southwest-3-1","eu-west-3","eu-west-4","private-cloud"]},{"type":"null"}]},"convertToOnDemandOnExpiry":{"anyOf":[{"type":"boolean"},{"type":"null"}]},"managedK8sClusterId":{"anyOf":[{"type":"integer","minimum":-2147483648,"maximum":2147483647},{"type":"null"}]},"gpuType":{"type":"string","enum":["h100","h200","b200"]},"gpuCount":{"type":"integer","minimum":-2147483648,"maximum":2147483647},"meta":{}},"required":["id","createdAt","updatedAt","deletedAt","userId","orgId","startedAt","terminatedAt","externalId","rentalId","providerData","rentalType","name","label","region","convertToOnDemandOnExpiry","managedK8sClusterId","gpuType","gpuCount"],"additionalProperties":false}}}},"400":{"description":"Invalid input data","content":{"application/json":{"schema":{"$ref":"#/components/schemas/error.BAD_REQUEST"}}}},"401":{"description":"Authorization not provided","content":{"application/json":{"schema":{"$ref":"#/components/schemas/error.UNAUTHORIZED"}}}},"403":{"description":"Insufficient access","content":{"application/json":{"schema":{"$ref":"#/components/schemas/error.FORBIDDEN"}}}},"500":{"description":"Internal server error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/error.INTERNAL_SERVER_ERROR"}}}}}},"get":{"operationId":"ondemand-getActiveBareMetalRentals","summary":"Get a list of active bare metal rentals","description":"Get a list of active bare metal rentals","security":[{"Authorization":[]}],"parameters":[],"responses":{"200":{"description":"Successful response","content":{"application/json":{"schema":{"type":"array","items":{"type":"object","properties":{"id":{"type":"integer","minimum":-2147483648,"maximum":2147483647},"createdAt":{"type":"string"},"updatedAt":{"anyOf":[{"type":"string"},{"type":"null"}]},"deletedAt":{"anyOf":[{"type":"string"},{"type":"null"}]},"userId":{"type":"string","maxLength":50},"orgId":{"anyOf":[{},{"type":"null"}]},"startedAt":{"anyOf":[{"type":"string"},{"type":"null"}]},"terminatedAt":{"anyOf":[{"type":"string"},{"type":"null"}]},"externalId":{"type":"string"},"rentalId":{},"providerData":{"oneOf":[{"type":"object","properties":{"externalId":{"type":"string"},"sshNetworking":{"type":"array","items":{"type":"object","properties":{"host":{"type":"string"},"port":{"type":"number"},"user":{"type":"string"}},"required":["host","port","user"],"additionalProperties":false}},"nodeNetworking":{"type":"array","items":{"type":"object","properties":{"publicIp":{"type":"string"},"privateIp":{"type":"string"}},"required":["publicIp","privateIp"],"additionalProperties":false}},"networkType":{"type":"string","enum":["infiniband","ethernet"]},"gpuFormFactor":{"type":"string","enum":["sxm5","sxm6","pcie"]},"providerId":{"type":"string","const":"nebius"},"resources":{"type":"object","properties":{"cpuModel":{"type":"string"},"gpuCount":{"type":"number"},"ramGb":{"type":"number"},"storageGb":{"type":"number"},"vcpuCount":{"type":"number"}},"required":["cpuModel","gpuCount","ramGb","storageGb","vcpuCount"],"additionalProperties":false}},"required":["providerId","resources"],"additionalProperties":false},{"type":"object","properties":{"externalId":{"type":"string"},"sshNetworking":{"type":"array","items":{"type":"object","properties":{"host":{"type":"string"},"port":{"type":"number"},"user":{"type":"string"}},"required":["host","port","user"],"additionalProperties":false}},"nodeNetworking":{"type":"array","items":{"type":"object","properties":{"publicIp":{"type":"string"},"privateIp":{"type":"string"}},"required":["publicIp","privateIp"],"additionalProperties":false}},"networkType":{"type":"string","enum":["infiniband","ethernet"]},"gpuFormFactor":{"type":"string","enum":["sxm5","sxm6","pcie"]},"providerId":{"type":"string","const":"voltage-park"},"resources":{"anyOf":[{"type":"object","properties":{"cpuModel":{"type":"string"},"gpuCount":{"type":"number"},"ramGb":{"type":"number"},"storageGb":{"type":"number"},"cpuCount":{"type":"number"}},"required":["cpuModel","gpuCount","ramGb","storageGb","cpuCount"],"additionalProperties":false},{"type":"object","properties":{"cpuModel":{"type":"string"},"gpuCount":{"type":"number"},"ramGb":{"type":"number"},"storageGb":{"type":"number"},"vcpuCount":{"type":"number"}},"required":["cpuModel","gpuCount","ramGb","storageGb","vcpuCount"],"additionalProperties":false}]},"subOrder":{"type":"string"},"portForwards":{"type":"array","items":{"type":"object","properties":{"externalPort":{"type":"number"},"internalPort":{"type":"number"}},"required":["externalPort","internalPort"],"additionalProperties":false}}},"required":["networkType","providerId","resources"],"additionalProperties":false},{"type":"object","properties":{"externalId":{"type":"string"},"sshNetworking":{"type":"array","items":{"type":"object","properties":{"host":{"type":"string"},"port":{"type":"number"},"user":{"type":"string"}},"required":["host","port","user"],"additionalProperties":false}},"nodeNetworking":{"type":"array","items":{"type":"object","properties":{"publicIp":{"type":"string"},"privateIp":{"type":"string"}},"required":["publicIp","privateIp"],"additionalProperties":false}},"networkType":{"type":"string","enum":["infiniband","ethernet"]},"gpuFormFactor":{"type":"string","enum":["sxm5","sxm6","pcie"]},"providerId":{"type":"string","const":"gcore"},"resources":{"type":"object","properties":{"cpuModel":{"type":"string"},"gpuCount":{"type":"number"},"ramGb":{"type":"number"},"storageGb":{"type":"number"},"cpuCount":{"type":"number"}},"required":["cpuModel","gpuCount","ramGb","storageGb","cpuCount"],"additionalProperties":false}},"required":["providerId","resources"],"additionalProperties":false},{"type":"object","properties":{"externalId":{"type":"string"},"sshNetworking":{"type":"array","items":{"type":"object","properties":{"host":{"type":"string"},"port":{"type":"number"},"user":{"type":"string"}},"required":["host","port","user"],"additionalProperties":false}},"nodeNetworking":{"type":"array","items":{"type":"object","properties":{"publicIp":{"type":"string"},"privateIp":{"type":"string"}},"required":["publicIp","privateIp"],"additionalProperties":false}},"networkType":{"type":"string","enum":["infiniband","ethernet"]},"gpuFormFactor":{"type":"string","enum":["sxm5","sxm6","pcie"]},"providerId":{"type":"string","const":"horizon"},"publicIpAddressId":{"type":"string"},"resources":{"type":"object","properties":{"cpuModel":{"type":"string"},"gpuCount":{"type":"number"},"ramGb":{"type":"number"},"storageGb":{"type":"number"},"vcpuCount":{"type":"number"}},"required":["cpuModel","gpuCount","ramGb","storageGb","vcpuCount"],"additionalProperties":false}},"required":["providerId","resources"],"additionalProperties":false},{"type":"object","properties":{"externalId":{"type":"string"},"sshNetworking":{"type":"array","items":{"type":"object","properties":{"host":{"type":"string"},"port":{"type":"number"},"user":{"type":"string"}},"required":["host","port","user"],"additionalProperties":false}},"nodeNetworking":{"type":"array","items":{"type":"object","properties":{"publicIp":{"type":"string"},"privateIp":{"type":"string"}},"required":["publicIp","privateIp"],"additionalProperties":false}},"networkType":{"type":"string","enum":["infiniband","ethernet"]},"gpuFormFactor":{"type":"string","enum":["sxm5","sxm6","pcie"]},"providerId":{"type":"string","const":"digital-ocean"},"resources":{"type":"object","properties":{"cpuModel":{"type":"string"},"gpuCount":{"type":"number"},"ramGb":{"type":"number"},"storageGb":{"type":"number"},"vcpuCount":{"type":"number"}},"required":["cpuModel","gpuCount","ramGb","storageGb","vcpuCount"],"additionalProperties":false},"poolType":{"anyOf":[{"type":"string","enum":["public","contracted"]},{"type":"null"}]}},"required":["providerId","resources"],"additionalProperties":false},{"type":"object","properties":{"externalId":{"type":"string"},"sshNetworking":{"type":"array","items":{"type":"object","properties":{"host":{"type":"string"},"port":{"type":"number"},"user":{"type":"string"}},"required":["host","port","user"],"additionalProperties":false}},"nodeNetworking":{"type":"array","items":{"type":"object","properties":{"publicIp":{"type":"string"},"privateIp":{"type":"string"}},"required":["publicIp","privateIp"],"additionalProperties":false}},"networkType":{"type":"string","enum":["infiniband","ethernet"]},"gpuFormFactor":{"type":"string","enum":["sxm5","sxm6","pcie"]},"providerId":{"type":"string","const":"verda"},"resources":{"type":"object","properties":{"cpuModel":{"type":"string"},"gpuCount":{"type":"number"},"ramGb":{"type":"number"},"storageGb":{"type":"number"},"vcpuCount":{"type":"number"}},"required":["cpuModel","gpuCount","ramGb","storageGb","vcpuCount"],"additionalProperties":false}},"required":["providerId","resources"],"additionalProperties":false},{"type":"object","properties":{"externalId":{"type":"string"},"sshNetworking":{"type":"array","items":{"type":"object","properties":{"host":{"type":"string"},"port":{"type":"number"},"user":{"type":"string"}},"required":["host","port","user"],"additionalProperties":false}},"nodeNetworking":{"type":"array","items":{"type":"object","properties":{"publicIp":{"type":"string"},"privateIp":{"type":"string"}},"required":["publicIp","privateIp"],"additionalProperties":false}},"networkType":{"type":"string","enum":["infiniband","ethernet"]},"gpuFormFactor":{"type":"string","enum":["sxm5","sxm6","pcie"]},"providerId":{"type":"string","const":"hyperstack"},"resources":{"type":"object","properties":{"cpuModel":{"type":"string"},"gpuCount":{"type":"number"},"ramGb":{"type":"number"},"storageGb":{"type":"number"},"vcpuCount":{"type":"number"}},"required":["cpuModel","gpuCount","ramGb","storageGb","vcpuCount"],"additionalProperties":false}},"required":["providerId","resources"],"additionalProperties":false},{"type":"object","properties":{"externalId":{"type":"string"},"sshNetworking":{"type":"array","items":{"type":"object","properties":{"host":{"type":"string"},"port":{"type":"number"},"user":{"type":"string"}},"required":["host","port","user"],"additionalProperties":false}},"nodeNetworking":{"type":"array","items":{"type":"object","properties":{"publicIp":{"type":"string"},"privateIp":{"type":"string"}},"required":["publicIp","privateIp"],"additionalProperties":false}},"networkType":{"type":"string","enum":["infiniband","ethernet"]},"gpuFormFactor":{"type":"string","enum":["sxm5","sxm6","pcie"]},"providerId":{"type":"string","const":"forge"},"resources":{"anyOf":[{"type":"object","properties":{"cpuModel":{"type":"string"},"gpuCount":{"type":"number"},"ramGb":{"type":"number"},"storageGb":{"type":"number"},"cpuCount":{"type":"number"}},"required":["cpuModel","gpuCount","ramGb","storageGb","cpuCount"],"additionalProperties":false},{"type":"object","properties":{"cpuModel":{"type":"string"},"gpuCount":{"type":"number"},"ramGb":{"type":"number"},"storageGb":{"type":"number"},"vcpuCount":{"type":"number"}},"required":["cpuModel","gpuCount","ramGb","storageGb","vcpuCount"],"additionalProperties":false}]},"customPorts":{"maxItems":20,"type":"array","items":{"type":"integer","minimum":1,"maximum":65535}}},"required":["providerId","resources"],"additionalProperties":false},{"type":"object","properties":{"externalId":{"type":"string"},"sshNetworking":{"type":"array","items":{"type":"object","properties":{"host":{"type":"string"},"port":{"type":"number"},"user":{"type":"string"}},"required":["host","port","user"],"additionalProperties":false}},"nodeNetworking":{"type":"array","items":{"type":"object","properties":{"publicIp":{"type":"string"},"privateIp":{"type":"string"}},"required":["publicIp","privateIp"],"additionalProperties":false}},"networkType":{"type":"string","enum":["infiniband","ethernet"]},"gpuFormFactor":{"type":"string","enum":["sxm5","sxm6","pcie"]},"providerId":{"type":"string","const":"private-cloud"},"gpuModel":{"type":"string"},"location":{"type":"string"},"benchmark":{"type":"object","propertyNames":{"type":"string"},"additionalProperties":{}},"resources":{"anyOf":[{"type":"object","properties":{"cpuModel":{"type":"string"},"gpuCount":{"type":"number"},"ramGb":{"type":"number"},"storageGb":{"type":"number"},"cpuCount":{"type":"number"}},"required":["cpuModel","gpuCount","ramGb","storageGb","cpuCount"],"additionalProperties":false},{"type":"object","properties":{"cpuModel":{"type":"string"},"gpuCount":{"type":"number"},"ramGb":{"type":"number"},"storageGb":{"type":"number"},"vcpuCount":{"type":"number"}},"required":["cpuModel","gpuCount","ramGb","storageGb","vcpuCount"],"additionalProperties":false}]},"nodes":{"type":"array","items":{"type":"object","properties":{"role":{"default":"compute","type":"string","enum":["login","head","compute"]},"hostname":{"type":"string"},"publicIp":{"type":"string"},"privateIp":{"type":"string"}},"required":["role","privateIp"],"additionalProperties":false}},"sshUser":{"type":"string"},"sshPort":{"type":"number"},"extra":{"type":"object","propertyNames":{"type":"string"},"additionalProperties":{}}},"required":["providerId","resources","nodes","sshUser"],"additionalProperties":false},{"type":"object","properties":{"externalId":{"type":"string"},"sshNetworking":{"type":"array","items":{"type":"object","properties":{"host":{"type":"string"},"port":{"type":"number"},"user":{"type":"string"}},"required":["host","port","user"],"additionalProperties":false}},"nodeNetworking":{"type":"array","items":{"type":"object","properties":{"publicIp":{"type":"string"},"privateIp":{"type":"string"}},"required":["publicIp","privateIp"],"additionalProperties":false}},"networkType":{"type":"string","enum":["infiniband","ethernet"]},"gpuFormFactor":{"type":"string","enum":["sxm5","sxm6","pcie"]},"providerId":{"type":"string","const":"mock"},"resources":{"type":"object","properties":{"cpuModel":{"type":"string"},"gpuCount":{"type":"number"},"ramGb":{"type":"number"},"storageGb":{"type":"number"},"vcpuCount":{"type":"number"}},"required":["cpuModel","gpuCount","ramGb","storageGb","vcpuCount"],"additionalProperties":false},"customPorts":{"maxItems":20,"type":"array","items":{"type":"integer","minimum":1,"maximum":65535}}},"required":["providerId","resources"],"additionalProperties":false}],"type":"object"},"name":{"anyOf":[{"type":"string"},{"type":"null"}]},"label":{"anyOf":[{"type":"string"},{"type":"null"}]},"convertToOnDemandOnExpiry":{"anyOf":[{"type":"boolean"},{"type":"null"}]},"managedK8sClusterId":{"anyOf":[{"type":"integer","minimum":-2147483648,"maximum":2147483647},{"type":"null"}]},"gpuType":{"type":"string","enum":["h100","h200","b200"]},"gpuCount":{"type":"integer","minimum":-2147483648,"maximum":2147483647},"currentTerm":{"oneOf":[{"type":"object","properties":{"effectiveAt":{"type":"string"},"termType":{"type":"string","const":"on-demand"},"costPerHour":{"type":"number"},"reservedUntil":{"type":"null"},"reservationEndsAt":{"type":"null"},"termPeriodDays":{"type":"null"},"discountPercentage":{"type":"null"},"originalCostPerHour":{"type":"null"}},"required":["effectiveAt","termType","costPerHour","reservedUntil","reservationEndsAt","termPeriodDays","discountPercentage","originalCostPerHour"],"additionalProperties":false},{"type":"object","properties":{"effectiveAt":{"type":"string"},"termType":{"type":"string","const":"reserved"},"costPerHour":{"type":"number"},"reservedUntil":{"anyOf":[{"type":"string"},{"type":"null"}]},"reservationEndsAt":{"anyOf":[{"type":"string"},{"type":"null"}]},"termPeriodDays":{"type":"number"},"discountPercentage":{"type":"number"},"originalCostPerHour":{"type":"number"}},"required":["effectiveAt","termType","costPerHour","reservedUntil","reservationEndsAt","termPeriodDays","discountPercentage","originalCostPerHour"],"additionalProperties":false},{"type":"object","properties":{"effectiveAt":{"type":"string"},"termType":{"type":"string","const":"private-cloud"},"costPerHour":{"type":"number"},"reservedUntil":{"type":"null"},"reservationEndsAt":{"type":"null"},"termPeriodDays":{"type":"null"},"discountPercentage":{"type":"null"},"originalCostPerHour":{"type":"null"}},"required":["effectiveAt","termType","costPerHour","reservedUntil","reservationEndsAt","termPeriodDays","discountPercentage","originalCostPerHour"],"additionalProperties":false}],"type":"object"},"rentalType":{"type":"string","const":"bare-metal"},"meta":{"anyOf":[{"type":"object","properties":{"monitoring_enabled":{"type":"boolean"},"termination_reason":{"type":"string"},"attached_storage":{"type":"array","items":{"type":"object","properties":{"id":{"type":"integer","exclusiveMinimum":0,"maximum":9007199254740991},"cost_per_hour":{"type":"number","exclusiveMinimum":0},"size_in_gb":{"type":"integer","exclusiveMinimum":0,"maximum":9007199254740991},"label":{"type":"string"},"vip":{"type":"string"},"attached_instance_ids":{"type":"array","items":{"type":"number"}}},"required":["id","cost_per_hour","size_in_gb","label","vip","attached_instance_ids"],"additionalProperties":false}},"rental_type":{"type":"string"},"sales_contract_external_id":{"type":"string"}},"additionalProperties":false},{"type":"null"}]},"attachedStorage":{"type":"array","items":{"type":"object","properties":{"id":{"type":"integer","exclusiveMinimum":0,"maximum":9007199254740991},"cost_per_hour":{"type":"number","exclusiveMinimum":0},"size_in_gb":{"type":"integer","exclusiveMinimum":0,"maximum":9007199254740991},"label":{"type":"string"},"vip":{"type":"string"},"attached_instance_ids":{"type":"array","items":{"type":"number"}}},"required":["id","cost_per_hour","size_in_gb","label","vip","attached_instance_ids"],"additionalProperties":false}},"gpuFormFactor":{"type":"string","enum":["sxm5","sxm6","pcie"]},"nodes":{"type":"array","items":{"type":"object","properties":{"cpuModel":{"type":"string"},"gpuCount":{"type":"number"},"ramGb":{"type":"number"},"storageGb":{"type":"number"},"cpuCount":{"type":"number"}},"required":["cpuModel","gpuCount","ramGb","storageGb","cpuCount"],"additionalProperties":false}},"connectionType":{"type":"string","enum":["infiniband","ethernet"]},"ethernetVariant":{"type":"string","enum":["normal","rocev2"]},"region":{"type":"string","enum":["us-central-1","us-central-2","eu-north-2","eu-west-2","eu-north-4","eu-north-5","us-east-1","us-east-2","ca-east-3","eu-north-6","eu-north-7","eu-north-8","ca-west-1","ca-east-1","us-central-3","us-southeast-1","me-central-1","ca-east-2","eu-west-1","us-southeast-2","jp-east-1","mock-region","uk-central-3","uk-southeast-3","eu-southwest-3","eu-southwest-3-1","eu-west-3","eu-west-4","private-cloud"]},"createdBy":{"type":"object","properties":{"id":{"type":"string","maxLength":50},"name":{"anyOf":[{"type":"string","maxLength":255},{"type":"null"}]},"email":{"type":"string","maxLength":255},"picture":{"anyOf":[{"type":"string"},{"type":"null"}]}},"required":["id","name","email","picture"],"additionalProperties":false},"supportsFeature":{"type":"object","properties":{"attachedStorage":{"type":"boolean"}},"required":["attachedStorage"],"additionalProperties":false},"status":{"default":"Unknown","type":"string","enum":["Failed","Pending","Running","Terminating","Terminated","Unknown"]}},"required":["id","createdAt","updatedAt","deletedAt","userId","orgId","startedAt","terminatedAt","externalId","rentalId","providerData","name","label","convertToOnDemandOnExpiry","managedK8sClusterId","gpuType","gpuCount","currentTerm","rentalType","gpuFormFactor","nodes","connectionType","region","createdBy","supportsFeature","status"],"additionalProperties":false}}}}},"400":{"description":"Invalid input data","content":{"application/json":{"schema":{"$ref":"#/components/schemas/error.BAD_REQUEST"}}}},"401":{"description":"Authorization not provided","content":{"application/json":{"schema":{"$ref":"#/components/schemas/error.UNAUTHORIZED"}}}},"403":{"description":"Insufficient access","content":{"application/json":{"schema":{"$ref":"#/components/schemas/error.FORBIDDEN"}}}},"404":{"description":"Not found","content":{"application/json":{"schema":{"$ref":"#/components/schemas/error.NOT_FOUND"}}}},"500":{"description":"Internal server error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/error.INTERNAL_SERVER_ERROR"}}}}}}},"/v2/alpha/on-demand/request-reservation":{"post":{"operationId":"ondemand-requestReservation","summary":"Request a reservation","description":"Request a reservation for a large instance","security":[{"Authorization":[]}],"parameters":[],"requestBody":{"required":true,"content":{"application/json":{"schema":{"type":"object","properties":{"gpuCount":{"type":"number","minimum":1}},"required":["gpuCount"]}}}},"responses":{"200":{"description":"Successful response","content":{"application/json":{"schema":{"type":"object","properties":{"message":{"type":"string"}},"required":["message"],"additionalProperties":false}}}},"400":{"description":"Invalid input data","content":{"application/json":{"schema":{"$ref":"#/components/schemas/error.BAD_REQUEST"}}}},"401":{"description":"Authorization not provided","content":{"application/json":{"schema":{"$ref":"#/components/schemas/error.UNAUTHORIZED"}}}},"403":{"description":"Insufficient access","content":{"application/json":{"schema":{"$ref":"#/components/schemas/error.FORBIDDEN"}}}},"500":{"description":"Internal server error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/error.INTERNAL_SERVER_ERROR"}}}}}}},"/v2/alpha/on-demand/storage-volumes":{"post":{"operationId":"ondemand-createStorageVolume","summary":"Create a storage volume","description":"Create a storage volume","security":[{"Authorization":[]}],"parameters":[],"requestBody":{"required":true,"content":{"application/json":{"schema":{"type":"object","properties":{"region":{"anyOf":[{"type":"string","enum":["us-central-1","us-central-2","eu-north-2","eu-west-2","eu-north-4","eu-north-5","us-east-1","us-east-2","ca-east-3","eu-north-6","eu-north-7","eu-north-8","ca-west-1","ca-east-1","us-central-3","us-southeast-1","me-central-1","ca-east-2","eu-west-1","us-southeast-2","jp-east-1","mock-region"]},{"type":"string","enum":["us-central-1","uk-central-3","uk-southeast-3","eu-southwest-3","eu-southwest-3-1","eu-west-3","eu-west-4"]}]},"label":{"type":"string","minLength":4,"maxLength":255,"pattern":"^[a-zA-Z0-9_-]+$"},"sizeInGb":{"type":"integer","minimum":256,"maximum":64000,"multipleOf":256},"rentalIds":{"type":"array","items":{"type":"integer","exclusiveMinimum":0,"maximum":9007199254740991}}},"required":["region","label","sizeInGb"]}}}},"responses":{"200":{"description":"Successful response","content":{"application/json":{"schema":{"type":"object","properties":{"storageVolumeId":{"type":"integer","exclusiveMinimum":0,"maximum":9007199254740991},"region":{"anyOf":[{"type":"string","enum":["us-central-1","us-central-2","eu-north-2","eu-west-2","eu-north-4","eu-north-5","us-east-1","us-east-2","ca-east-3","eu-north-6","eu-north-7","eu-north-8","ca-west-1","ca-east-1","us-central-3","us-southeast-1","me-central-1","ca-east-2","eu-west-1","us-southeast-2","jp-east-1","mock-region"]},{"type":"string","enum":["us-central-1","uk-central-3","uk-southeast-3","eu-southwest-3","eu-southwest-3-1","eu-west-3","eu-west-4"]}]},"status":{"default":"unknown","type":"string","enum":["active","inactive","unknown"]},"label":{"type":"string","minLength":4,"maxLength":255,"pattern":"^[a-zA-Z0-9_-]+$"},"sizeInGb":{"type":"integer","minimum":256,"maximum":64000,"multipleOf":256},"attachedRentals":{"type":"array","items":{"type":"integer","exclusiveMinimum":0,"maximum":9007199254740991}},"message":{"type":"string"}},"required":["storageVolumeId","region","status","label","sizeInGb","attachedRentals","message"],"additionalProperties":false}}}},"400":{"description":"Invalid input data","content":{"application/json":{"schema":{"$ref":"#/components/schemas/error.BAD_REQUEST"}}}},"401":{"description":"Authorization not provided","content":{"application/json":{"schema":{"$ref":"#/components/schemas/error.UNAUTHORIZED"}}}},"403":{"description":"Insufficient access","content":{"application/json":{"schema":{"$ref":"#/components/schemas/error.FORBIDDEN"}}}},"500":{"description":"Internal server error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/error.INTERNAL_SERVER_ERROR"}}}}}},"get":{"operationId":"ondemand-getStorageVolumes","summary":"Get a list of storage volumes","description":"Get a list of storage volumes","security":[{"Authorization":[]}],"parameters":[],"responses":{"200":{"description":"Successful response","content":{"application/json":{"schema":{"type":"array","items":{"type":"object","properties":{"id":{"type":"integer","minimum":-2147483648,"maximum":2147483647},"createdAt":{"type":"string"},"updatedAt":{"anyOf":[{"type":"string"},{"type":"null"}]},"deletedAt":{"anyOf":[{"type":"string"},{"type":"null"}]},"userId":{"type":"string","maxLength":50},"orgId":{"anyOf":[{},{"type":"null"}]},"startedAt":{"anyOf":[{"type":"string"},{"type":"null"}]},"terminatedAt":{"anyOf":[{"type":"string"},{"type":"null"}]},"externalId":{"type":"string"},"sizeGb":{"type":"integer","minimum":-2147483648,"maximum":2147483647},"label":{"type":"string"},"costPerHour":{"type":"number","minimum":-140737488355328,"maximum":140737488355327},"region":{"type":"string","enum":["us-central-1","us-central-2","eu-north-2","eu-west-2","eu-north-4","eu-north-5","us-east-1","us-east-2","ca-east-3","eu-north-6","eu-north-7","eu-north-8","ca-west-1","ca-east-1","us-central-3","us-southeast-1","me-central-1","ca-east-2","eu-west-1","us-southeast-2","jp-east-1","mock-region","uk-central-3","uk-southeast-3","eu-southwest-3","eu-southwest-3-1","eu-west-3","eu-west-4"]},"storageVolumeId":{},"meta":{"type":"object","properties":{"termination_reason":{"type":"string"}},"additionalProperties":false},"status":{"default":"unknown","type":"string","enum":["active","inactive","unknown"]},"attachedRentals":{"type":"array","items":{"type":"integer","exclusiveMinimum":0,"maximum":9007199254740991}},"sizeInGb":{"type":"integer","exclusiveMinimum":0,"maximum":9007199254740991},"vip":{"type":"string"}},"required":["id","createdAt","updatedAt","deletedAt","userId","orgId","startedAt","terminatedAt","externalId","sizeGb","label","costPerHour","region","storageVolumeId","meta","status","attachedRentals","sizeInGb","vip"],"additionalProperties":false}}}}},"400":{"description":"Invalid input data","content":{"application/json":{"schema":{"$ref":"#/components/schemas/error.BAD_REQUEST"}}}},"401":{"description":"Authorization not provided","content":{"application/json":{"schema":{"$ref":"#/components/schemas/error.UNAUTHORIZED"}}}},"403":{"description":"Insufficient access","content":{"application/json":{"schema":{"$ref":"#/components/schemas/error.FORBIDDEN"}}}},"404":{"description":"Not found","content":{"application/json":{"schema":{"$ref":"#/components/schemas/error.NOT_FOUND"}}}},"500":{"description":"Internal server error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/error.INTERNAL_SERVER_ERROR"}}}}}}},"/v2/alpha/on-demand/virtual-machine-rentals":{"post":{"operationId":"ondemand-createVirtualMachineRental","summary":"Create a virtual machine rental","description":"Create a virtual machine rental","security":[{"Authorization":[]}],"parameters":[],"requestBody":{"required":true,"content":{"application/json":{"schema":{"type":"object","properties":{"gpuCount":{"type":"number"},"networkType":{"default":"ethernet","type":"string","enum":["infiniband","ethernet"]},"region":{"default":"us-central-1","type":"string","enum":["us-central-1","us-central-2","eu-north-2","eu-west-2","eu-north-4","eu-north-5","us-east-1","us-east-2","ca-east-3","eu-north-6","eu-north-7","eu-north-8","ca-west-1","ca-east-1","us-central-3","us-southeast-1","me-central-1","ca-east-2","eu-west-1","us-southeast-2","jp-east-1","mock-region"]},"gpuType":{"default":"h100","type":"string","enum":["h100","h200","b200"]},"label":{"type":"string"},"termType":{"default":"on-demand","type":"string","enum":["on-demand","reserved"]},"termPeriodDays":{"type":"number"},"discountPercentage":{"default":0,"type":"number"},"monitoringEnabled":{"type":"boolean"},"customPorts":{"maxItems":20,"type":"array","items":{"type":"integer","minimum":1,"maximum":65535}},"convertToOnDemandOnExpiry":{"default":true,"type":"boolean"}},"required":["gpuCount"]}}}},"responses":{"200":{"description":"Successful response","content":{"application/json":{"schema":{"type":"object","properties":{"id":{"type":"integer","minimum":-2147483648,"maximum":2147483647},"createdAt":{"type":"string"},"updatedAt":{"anyOf":[{"type":"string"},{"type":"null"}]},"deletedAt":{"anyOf":[{"type":"string"},{"type":"null"}]},"userId":{"type":"string","maxLength":50},"orgId":{"anyOf":[{},{"type":"null"}]},"startedAt":{"anyOf":[{"type":"string"},{"type":"null"}]},"terminatedAt":{"anyOf":[{"type":"string"},{"type":"null"}]},"externalId":{"type":"string"},"rentalId":{},"providerData":{"oneOf":[{"type":"object","properties":{"externalId":{"type":"string"},"sshNetworking":{"type":"array","items":{"type":"object","properties":{"host":{"type":"string"},"port":{"type":"number"},"user":{"type":"string"}},"required":["host","port","user"],"additionalProperties":false}},"nodeNetworking":{"type":"array","items":{"type":"object","properties":{"publicIp":{"type":"string"},"privateIp":{"type":"string"}},"required":["publicIp","privateIp"],"additionalProperties":false}},"networkType":{"type":"string","enum":["infiniband","ethernet"]},"gpuFormFactor":{"type":"string","enum":["sxm5","sxm6","pcie"]},"providerId":{"type":"string","const":"nebius"},"resources":{"type":"object","properties":{"cpuModel":{"type":"string"},"gpuCount":{"type":"number"},"ramGb":{"type":"number"},"storageGb":{"type":"number"},"vcpuCount":{"type":"number"}},"required":["cpuModel","gpuCount","ramGb","storageGb","vcpuCount"],"additionalProperties":false}},"required":["providerId","resources"],"additionalProperties":false},{"type":"object","properties":{"externalId":{"type":"string"},"sshNetworking":{"type":"array","items":{"type":"object","properties":{"host":{"type":"string"},"port":{"type":"number"},"user":{"type":"string"}},"required":["host","port","user"],"additionalProperties":false}},"nodeNetworking":{"type":"array","items":{"type":"object","properties":{"publicIp":{"type":"string"},"privateIp":{"type":"string"}},"required":["publicIp","privateIp"],"additionalProperties":false}},"networkType":{"type":"string","enum":["infiniband","ethernet"]},"gpuFormFactor":{"type":"string","enum":["sxm5","sxm6","pcie"]},"providerId":{"type":"string","const":"voltage-park"},"resources":{"anyOf":[{"type":"object","properties":{"cpuModel":{"type":"string"},"gpuCount":{"type":"number"},"ramGb":{"type":"number"},"storageGb":{"type":"number"},"cpuCount":{"type":"number"}},"required":["cpuModel","gpuCount","ramGb","storageGb","cpuCount"],"additionalProperties":false},{"type":"object","properties":{"cpuModel":{"type":"string"},"gpuCount":{"type":"number"},"ramGb":{"type":"number"},"storageGb":{"type":"number"},"vcpuCount":{"type":"number"}},"required":["cpuModel","gpuCount","ramGb","storageGb","vcpuCount"],"additionalProperties":false}]},"subOrder":{"type":"string"},"portForwards":{"type":"array","items":{"type":"object","properties":{"externalPort":{"type":"number"},"internalPort":{"type":"number"}},"required":["externalPort","internalPort"],"additionalProperties":false}}},"required":["networkType","providerId","resources"],"additionalProperties":false},{"type":"object","properties":{"externalId":{"type":"string"},"sshNetworking":{"type":"array","items":{"type":"object","properties":{"host":{"type":"string"},"port":{"type":"number"},"user":{"type":"string"}},"required":["host","port","user"],"additionalProperties":false}},"nodeNetworking":{"type":"array","items":{"type":"object","properties":{"publicIp":{"type":"string"},"privateIp":{"type":"string"}},"required":["publicIp","privateIp"],"additionalProperties":false}},"networkType":{"type":"string","enum":["infiniband","ethernet"]},"gpuFormFactor":{"type":"string","enum":["sxm5","sxm6","pcie"]},"providerId":{"type":"string","const":"gcore"},"resources":{"type":"object","properties":{"cpuModel":{"type":"string"},"gpuCount":{"type":"number"},"ramGb":{"type":"number"},"storageGb":{"type":"number"},"cpuCount":{"type":"number"}},"required":["cpuModel","gpuCount","ramGb","storageGb","cpuCount"],"additionalProperties":false}},"required":["providerId","resources"],"additionalProperties":false},{"type":"object","properties":{"externalId":{"type":"string"},"sshNetworking":{"type":"array","items":{"type":"object","properties":{"host":{"type":"string"},"port":{"type":"number"},"user":{"type":"string"}},"required":["host","port","user"],"additionalProperties":false}},"nodeNetworking":{"type":"array","items":{"type":"object","properties":{"publicIp":{"type":"string"},"privateIp":{"type":"string"}},"required":["publicIp","privateIp"],"additionalProperties":false}},"networkType":{"type":"string","enum":["infiniband","ethernet"]},"gpuFormFactor":{"type":"string","enum":["sxm5","sxm6","pcie"]},"providerId":{"type":"string","const":"horizon"},"publicIpAddressId":{"type":"string"},"resources":{"type":"object","properties":{"cpuModel":{"type":"string"},"gpuCount":{"type":"number"},"ramGb":{"type":"number"},"storageGb":{"type":"number"},"vcpuCount":{"type":"number"}},"required":["cpuModel","gpuCount","ramGb","storageGb","vcpuCount"],"additionalProperties":false}},"required":["providerId","resources"],"additionalProperties":false},{"type":"object","properties":{"externalId":{"type":"string"},"sshNetworking":{"type":"array","items":{"type":"object","properties":{"host":{"type":"string"},"port":{"type":"number"},"user":{"type":"string"}},"required":["host","port","user"],"additionalProperties":false}},"nodeNetworking":{"type":"array","items":{"type":"object","properties":{"publicIp":{"type":"string"},"privateIp":{"type":"string"}},"required":["publicIp","privateIp"],"additionalProperties":false}},"networkType":{"type":"string","enum":["infiniband","ethernet"]},"gpuFormFactor":{"type":"string","enum":["sxm5","sxm6","pcie"]},"providerId":{"type":"string","const":"digital-ocean"},"resources":{"type":"object","properties":{"cpuModel":{"type":"string"},"gpuCount":{"type":"number"},"ramGb":{"type":"number"},"storageGb":{"type":"number"},"vcpuCount":{"type":"number"}},"required":["cpuModel","gpuCount","ramGb","storageGb","vcpuCount"],"additionalProperties":false},"poolType":{"anyOf":[{"type":"string","enum":["public","contracted"]},{"type":"null"}]}},"required":["providerId","resources"],"additionalProperties":false},{"type":"object","properties":{"externalId":{"type":"string"},"sshNetworking":{"type":"array","items":{"type":"object","properties":{"host":{"type":"string"},"port":{"type":"number"},"user":{"type":"string"}},"required":["host","port","user"],"additionalProperties":false}},"nodeNetworking":{"type":"array","items":{"type":"object","properties":{"publicIp":{"type":"string"},"privateIp":{"type":"string"}},"required":["publicIp","privateIp"],"additionalProperties":false}},"networkType":{"type":"string","enum":["infiniband","ethernet"]},"gpuFormFactor":{"type":"string","enum":["sxm5","sxm6","pcie"]},"providerId":{"type":"string","const":"verda"},"resources":{"type":"object","properties":{"cpuModel":{"type":"string"},"gpuCount":{"type":"number"},"ramGb":{"type":"number"},"storageGb":{"type":"number"},"vcpuCount":{"type":"number"}},"required":["cpuModel","gpuCount","ramGb","storageGb","vcpuCount"],"additionalProperties":false}},"required":["providerId","resources"],"additionalProperties":false},{"type":"object","properties":{"externalId":{"type":"string"},"sshNetworking":{"type":"array","items":{"type":"object","properties":{"host":{"type":"string"},"port":{"type":"number"},"user":{"type":"string"}},"required":["host","port","user"],"additionalProperties":false}},"nodeNetworking":{"type":"array","items":{"type":"object","properties":{"publicIp":{"type":"string"},"privateIp":{"type":"string"}},"required":["publicIp","privateIp"],"additionalProperties":false}},"networkType":{"type":"string","enum":["infiniband","ethernet"]},"gpuFormFactor":{"type":"string","enum":["sxm5","sxm6","pcie"]},"providerId":{"type":"string","const":"hyperstack"},"resources":{"type":"object","properties":{"cpuModel":{"type":"string"},"gpuCount":{"type":"number"},"ramGb":{"type":"number"},"storageGb":{"type":"number"},"vcpuCount":{"type":"number"}},"required":["cpuModel","gpuCount","ramGb","storageGb","vcpuCount"],"additionalProperties":false}},"required":["providerId","resources"],"additionalProperties":false},{"type":"object","properties":{"externalId":{"type":"string"},"sshNetworking":{"type":"array","items":{"type":"object","properties":{"host":{"type":"string"},"port":{"type":"number"},"user":{"type":"string"}},"required":["host","port","user"],"additionalProperties":false}},"nodeNetworking":{"type":"array","items":{"type":"object","properties":{"publicIp":{"type":"string"},"privateIp":{"type":"string"}},"required":["publicIp","privateIp"],"additionalProperties":false}},"networkType":{"type":"string","enum":["infiniband","ethernet"]},"gpuFormFactor":{"type":"string","enum":["sxm5","sxm6","pcie"]},"providerId":{"type":"string","const":"forge"},"resources":{"anyOf":[{"type":"object","properties":{"cpuModel":{"type":"string"},"gpuCount":{"type":"number"},"ramGb":{"type":"number"},"storageGb":{"type":"number"},"cpuCount":{"type":"number"}},"required":["cpuModel","gpuCount","ramGb","storageGb","cpuCount"],"additionalProperties":false},{"type":"object","properties":{"cpuModel":{"type":"string"},"gpuCount":{"type":"number"},"ramGb":{"type":"number"},"storageGb":{"type":"number"},"vcpuCount":{"type":"number"}},"required":["cpuModel","gpuCount","ramGb","storageGb","vcpuCount"],"additionalProperties":false}]},"customPorts":{"maxItems":20,"type":"array","items":{"type":"integer","minimum":1,"maximum":65535}}},"required":["providerId","resources"],"additionalProperties":false},{"type":"object","properties":{"externalId":{"type":"string"},"sshNetworking":{"type":"array","items":{"type":"object","properties":{"host":{"type":"string"},"port":{"type":"number"},"user":{"type":"string"}},"required":["host","port","user"],"additionalProperties":false}},"nodeNetworking":{"type":"array","items":{"type":"object","properties":{"publicIp":{"type":"string"},"privateIp":{"type":"string"}},"required":["publicIp","privateIp"],"additionalProperties":false}},"networkType":{"type":"string","enum":["infiniband","ethernet"]},"gpuFormFactor":{"type":"string","enum":["sxm5","sxm6","pcie"]},"providerId":{"type":"string","const":"private-cloud"},"gpuModel":{"type":"string"},"location":{"type":"string"},"benchmark":{"type":"object","propertyNames":{"type":"string"},"additionalProperties":{}},"resources":{"anyOf":[{"type":"object","properties":{"cpuModel":{"type":"string"},"gpuCount":{"type":"number"},"ramGb":{"type":"number"},"storageGb":{"type":"number"},"cpuCount":{"type":"number"}},"required":["cpuModel","gpuCount","ramGb","storageGb","cpuCount"],"additionalProperties":false},{"type":"object","properties":{"cpuModel":{"type":"string"},"gpuCount":{"type":"number"},"ramGb":{"type":"number"},"storageGb":{"type":"number"},"vcpuCount":{"type":"number"}},"required":["cpuModel","gpuCount","ramGb","storageGb","vcpuCount"],"additionalProperties":false}]},"nodes":{"type":"array","items":{"type":"object","properties":{"role":{"default":"compute","type":"string","enum":["login","head","compute"]},"hostname":{"type":"string"},"publicIp":{"type":"string"},"privateIp":{"type":"string"}},"required":["role","privateIp"],"additionalProperties":false}},"sshUser":{"type":"string"},"sshPort":{"type":"number"},"extra":{"type":"object","propertyNames":{"type":"string"},"additionalProperties":{}}},"required":["providerId","resources","nodes","sshUser"],"additionalProperties":false},{"type":"object","properties":{"externalId":{"type":"string"},"sshNetworking":{"type":"array","items":{"type":"object","properties":{"host":{"type":"string"},"port":{"type":"number"},"user":{"type":"string"}},"required":["host","port","user"],"additionalProperties":false}},"nodeNetworking":{"type":"array","items":{"type":"object","properties":{"publicIp":{"type":"string"},"privateIp":{"type":"string"}},"required":["publicIp","privateIp"],"additionalProperties":false}},"networkType":{"type":"string","enum":["infiniband","ethernet"]},"gpuFormFactor":{"type":"string","enum":["sxm5","sxm6","pcie"]},"providerId":{"type":"string","const":"mock"},"resources":{"type":"object","properties":{"cpuModel":{"type":"string"},"gpuCount":{"type":"number"},"ramGb":{"type":"number"},"storageGb":{"type":"number"},"vcpuCount":{"type":"number"}},"required":["cpuModel","gpuCount","ramGb","storageGb","vcpuCount"],"additionalProperties":false},"customPorts":{"maxItems":20,"type":"array","items":{"type":"integer","minimum":1,"maximum":65535}}},"required":["providerId","resources"],"additionalProperties":false}],"type":"object"},"rentalType":{"type":"string","enum":["virtual-machine","bare-metal"]},"name":{"anyOf":[{"type":"string"},{"type":"null"}]},"label":{"anyOf":[{"type":"string"},{"type":"null"}]},"region":{"anyOf":[{"type":"string","enum":["us-central-1","us-central-2","eu-north-2","eu-west-2","eu-north-4","eu-north-5","us-east-1","us-east-2","ca-east-3","eu-north-6","eu-north-7","eu-north-8","ca-west-1","ca-east-1","us-central-3","us-southeast-1","me-central-1","ca-east-2","eu-west-1","us-southeast-2","jp-east-1","mock-region","uk-central-3","uk-southeast-3","eu-southwest-3","eu-southwest-3-1","eu-west-3","eu-west-4","private-cloud"]},{"type":"null"}]},"convertToOnDemandOnExpiry":{"anyOf":[{"type":"boolean"},{"type":"null"}]},"managedK8sClusterId":{"anyOf":[{"type":"integer","minimum":-2147483648,"maximum":2147483647},{"type":"null"}]},"gpuType":{"type":"string","enum":["h100","h200","b200"]},"gpuCount":{"type":"integer","minimum":-2147483648,"maximum":2147483647},"meta":{}},"required":["id","createdAt","updatedAt","deletedAt","userId","orgId","startedAt","terminatedAt","externalId","rentalId","providerData","rentalType","name","label","region","convertToOnDemandOnExpiry","managedK8sClusterId","gpuType","gpuCount"],"additionalProperties":false}}}},"400":{"description":"Invalid input data","content":{"application/json":{"schema":{"$ref":"#/components/schemas/error.BAD_REQUEST"}}}},"401":{"description":"Authorization not provided","content":{"application/json":{"schema":{"$ref":"#/components/schemas/error.UNAUTHORIZED"}}}},"403":{"description":"Insufficient access","content":{"application/json":{"schema":{"$ref":"#/components/schemas/error.FORBIDDEN"}}}},"500":{"description":"Internal server error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/error.INTERNAL_SERVER_ERROR"}}}}}},"get":{"operationId":"ondemand-getActiveVirtualMachineRentals","summary":"Get a list of active virtual machine rentals","description":"Get a list of active virtual machine rentals","security":[{"Authorization":[]}],"parameters":[],"responses":{"200":{"description":"Successful response","content":{"application/json":{"schema":{"type":"array","items":{"type":"object","properties":{"id":{"type":"integer","minimum":-2147483648,"maximum":2147483647},"createdAt":{"type":"string"},"updatedAt":{"anyOf":[{"type":"string"},{"type":"null"}]},"deletedAt":{"anyOf":[{"type":"string"},{"type":"null"}]},"userId":{"type":"string","maxLength":50},"orgId":{"anyOf":[{},{"type":"null"}]},"startedAt":{"anyOf":[{"type":"string"},{"type":"null"}]},"terminatedAt":{"anyOf":[{"type":"string"},{"type":"null"}]},"externalId":{"type":"string"},"rentalId":{},"providerData":{"oneOf":[{"type":"object","properties":{"externalId":{"type":"string"},"sshNetworking":{"type":"array","items":{"type":"object","properties":{"host":{"type":"string"},"port":{"type":"number"},"user":{"type":"string"}},"required":["host","port","user"],"additionalProperties":false}},"nodeNetworking":{"type":"array","items":{"type":"object","properties":{"publicIp":{"type":"string"},"privateIp":{"type":"string"}},"required":["publicIp","privateIp"],"additionalProperties":false}},"networkType":{"type":"string","enum":["infiniband","ethernet"]},"gpuFormFactor":{"type":"string","enum":["sxm5","sxm6","pcie"]},"providerId":{"type":"string","const":"nebius"},"resources":{"type":"object","properties":{"cpuModel":{"type":"string"},"gpuCount":{"type":"number"},"ramGb":{"type":"number"},"storageGb":{"type":"number"},"vcpuCount":{"type":"number"}},"required":["cpuModel","gpuCount","ramGb","storageGb","vcpuCount"],"additionalProperties":false}},"required":["providerId","resources"],"additionalProperties":false},{"type":"object","properties":{"externalId":{"type":"string"},"sshNetworking":{"type":"array","items":{"type":"object","properties":{"host":{"type":"string"},"port":{"type":"number"},"user":{"type":"string"}},"required":["host","port","user"],"additionalProperties":false}},"nodeNetworking":{"type":"array","items":{"type":"object","properties":{"publicIp":{"type":"string"},"privateIp":{"type":"string"}},"required":["publicIp","privateIp"],"additionalProperties":false}},"networkType":{"type":"string","enum":["infiniband","ethernet"]},"gpuFormFactor":{"type":"string","enum":["sxm5","sxm6","pcie"]},"providerId":{"type":"string","const":"voltage-park"},"resources":{"anyOf":[{"type":"object","properties":{"cpuModel":{"type":"string"},"gpuCount":{"type":"number"},"ramGb":{"type":"number"},"storageGb":{"type":"number"},"cpuCount":{"type":"number"}},"required":["cpuModel","gpuCount","ramGb","storageGb","cpuCount"],"additionalProperties":false},{"type":"object","properties":{"cpuModel":{"type":"string"},"gpuCount":{"type":"number"},"ramGb":{"type":"number"},"storageGb":{"type":"number"},"vcpuCount":{"type":"number"}},"required":["cpuModel","gpuCount","ramGb","storageGb","vcpuCount"],"additionalProperties":false}]},"subOrder":{"type":"string"},"portForwards":{"type":"array","items":{"type":"object","properties":{"externalPort":{"type":"number"},"internalPort":{"type":"number"}},"required":["externalPort","internalPort"],"additionalProperties":false}}},"required":["networkType","providerId","resources"],"additionalProperties":false},{"type":"object","properties":{"externalId":{"type":"string"},"sshNetworking":{"type":"array","items":{"type":"object","properties":{"host":{"type":"string"},"port":{"type":"number"},"user":{"type":"string"}},"required":["host","port","user"],"additionalProperties":false}},"nodeNetworking":{"type":"array","items":{"type":"object","properties":{"publicIp":{"type":"string"},"privateIp":{"type":"string"}},"required":["publicIp","privateIp"],"additionalProperties":false}},"networkType":{"type":"string","enum":["infiniband","ethernet"]},"gpuFormFactor":{"type":"string","enum":["sxm5","sxm6","pcie"]},"providerId":{"type":"string","const":"gcore"},"resources":{"type":"object","properties":{"cpuModel":{"type":"string"},"gpuCount":{"type":"number"},"ramGb":{"type":"number"},"storageGb":{"type":"number"},"cpuCount":{"type":"number"}},"required":["cpuModel","gpuCount","ramGb","storageGb","cpuCount"],"additionalProperties":false}},"required":["providerId","resources"],"additionalProperties":false},{"type":"object","properties":{"externalId":{"type":"string"},"sshNetworking":{"type":"array","items":{"type":"object","properties":{"host":{"type":"string"},"port":{"type":"number"},"user":{"type":"string"}},"required":["host","port","user"],"additionalProperties":false}},"nodeNetworking":{"type":"array","items":{"type":"object","properties":{"publicIp":{"type":"string"},"privateIp":{"type":"string"}},"required":["publicIp","privateIp"],"additionalProperties":false}},"networkType":{"type":"string","enum":["infiniband","ethernet"]},"gpuFormFactor":{"type":"string","enum":["sxm5","sxm6","pcie"]},"providerId":{"type":"string","const":"horizon"},"publicIpAddressId":{"type":"string"},"resources":{"type":"object","properties":{"cpuModel":{"type":"string"},"gpuCount":{"type":"number"},"ramGb":{"type":"number"},"storageGb":{"type":"number"},"vcpuCount":{"type":"number"}},"required":["cpuModel","gpuCount","ramGb","storageGb","vcpuCount"],"additionalProperties":false}},"required":["providerId","resources"],"additionalProperties":false},{"type":"object","properties":{"externalId":{"type":"string"},"sshNetworking":{"type":"array","items":{"type":"object","properties":{"host":{"type":"string"},"port":{"type":"number"},"user":{"type":"string"}},"required":["host","port","user"],"additionalProperties":false}},"nodeNetworking":{"type":"array","items":{"type":"object","properties":{"publicIp":{"type":"string"},"privateIp":{"type":"string"}},"required":["publicIp","privateIp"],"additionalProperties":false}},"networkType":{"type":"string","enum":["infiniband","ethernet"]},"gpuFormFactor":{"type":"string","enum":["sxm5","sxm6","pcie"]},"providerId":{"type":"string","const":"digital-ocean"},"resources":{"type":"object","properties":{"cpuModel":{"type":"string"},"gpuCount":{"type":"number"},"ramGb":{"type":"number"},"storageGb":{"type":"number"},"vcpuCount":{"type":"number"}},"required":["cpuModel","gpuCount","ramGb","storageGb","vcpuCount"],"additionalProperties":false},"poolType":{"anyOf":[{"type":"string","enum":["public","contracted"]},{"type":"null"}]}},"required":["providerId","resources"],"additionalProperties":false},{"type":"object","properties":{"externalId":{"type":"string"},"sshNetworking":{"type":"array","items":{"type":"object","properties":{"host":{"type":"string"},"port":{"type":"number"},"user":{"type":"string"}},"required":["host","port","user"],"additionalProperties":false}},"nodeNetworking":{"type":"array","items":{"type":"object","properties":{"publicIp":{"type":"string"},"privateIp":{"type":"string"}},"required":["publicIp","privateIp"],"additionalProperties":false}},"networkType":{"type":"string","enum":["infiniband","ethernet"]},"gpuFormFactor":{"type":"string","enum":["sxm5","sxm6","pcie"]},"providerId":{"type":"string","const":"verda"},"resources":{"type":"object","properties":{"cpuModel":{"type":"string"},"gpuCount":{"type":"number"},"ramGb":{"type":"number"},"storageGb":{"type":"number"},"vcpuCount":{"type":"number"}},"required":["cpuModel","gpuCount","ramGb","storageGb","vcpuCount"],"additionalProperties":false}},"required":["providerId","resources"],"additionalProperties":false},{"type":"object","properties":{"externalId":{"type":"string"},"sshNetworking":{"type":"array","items":{"type":"object","properties":{"host":{"type":"string"},"port":{"type":"number"},"user":{"type":"string"}},"required":["host","port","user"],"additionalProperties":false}},"nodeNetworking":{"type":"array","items":{"type":"object","properties":{"publicIp":{"type":"string"},"privateIp":{"type":"string"}},"required":["publicIp","privateIp"],"additionalProperties":false}},"networkType":{"type":"string","enum":["infiniband","ethernet"]},"gpuFormFactor":{"type":"string","enum":["sxm5","sxm6","pcie"]},"providerId":{"type":"string","const":"hyperstack"},"resources":{"type":"object","properties":{"cpuModel":{"type":"string"},"gpuCount":{"type":"number"},"ramGb":{"type":"number"},"storageGb":{"type":"number"},"vcpuCount":{"type":"number"}},"required":["cpuModel","gpuCount","ramGb","storageGb","vcpuCount"],"additionalProperties":false}},"required":["providerId","resources"],"additionalProperties":false},{"type":"object","properties":{"externalId":{"type":"string"},"sshNetworking":{"type":"array","items":{"type":"object","properties":{"host":{"type":"string"},"port":{"type":"number"},"user":{"type":"string"}},"required":["host","port","user"],"additionalProperties":false}},"nodeNetworking":{"type":"array","items":{"type":"object","properties":{"publicIp":{"type":"string"},"privateIp":{"type":"string"}},"required":["publicIp","privateIp"],"additionalProperties":false}},"networkType":{"type":"string","enum":["infiniband","ethernet"]},"gpuFormFactor":{"type":"string","enum":["sxm5","sxm6","pcie"]},"providerId":{"type":"string","const":"forge"},"resources":{"anyOf":[{"type":"object","properties":{"cpuModel":{"type":"string"},"gpuCount":{"type":"number"},"ramGb":{"type":"number"},"storageGb":{"type":"number"},"cpuCount":{"type":"number"}},"required":["cpuModel","gpuCount","ramGb","storageGb","cpuCount"],"additionalProperties":false},{"type":"object","properties":{"cpuModel":{"type":"string"},"gpuCount":{"type":"number"},"ramGb":{"type":"number"},"storageGb":{"type":"number"},"vcpuCount":{"type":"number"}},"required":["cpuModel","gpuCount","ramGb","storageGb","vcpuCount"],"additionalProperties":false}]},"customPorts":{"maxItems":20,"type":"array","items":{"type":"integer","minimum":1,"maximum":65535}}},"required":["providerId","resources"],"additionalProperties":false},{"type":"object","properties":{"externalId":{"type":"string"},"sshNetworking":{"type":"array","items":{"type":"object","properties":{"host":{"type":"string"},"port":{"type":"number"},"user":{"type":"string"}},"required":["host","port","user"],"additionalProperties":false}},"nodeNetworking":{"type":"array","items":{"type":"object","properties":{"publicIp":{"type":"string"},"privateIp":{"type":"string"}},"required":["publicIp","privateIp"],"additionalProperties":false}},"networkType":{"type":"string","enum":["infiniband","ethernet"]},"gpuFormFactor":{"type":"string","enum":["sxm5","sxm6","pcie"]},"providerId":{"type":"string","const":"private-cloud"},"gpuModel":{"type":"string"},"location":{"type":"string"},"benchmark":{"type":"object","propertyNames":{"type":"string"},"additionalProperties":{}},"resources":{"anyOf":[{"type":"object","properties":{"cpuModel":{"type":"string"},"gpuCount":{"type":"number"},"ramGb":{"type":"number"},"storageGb":{"type":"number"},"cpuCount":{"type":"number"}},"required":["cpuModel","gpuCount","ramGb","storageGb","cpuCount"],"additionalProperties":false},{"type":"object","properties":{"cpuModel":{"type":"string"},"gpuCount":{"type":"number"},"ramGb":{"type":"number"},"storageGb":{"type":"number"},"vcpuCount":{"type":"number"}},"required":["cpuModel","gpuCount","ramGb","storageGb","vcpuCount"],"additionalProperties":false}]},"nodes":{"type":"array","items":{"type":"object","properties":{"role":{"default":"compute","type":"string","enum":["login","head","compute"]},"hostname":{"type":"string"},"publicIp":{"type":"string"},"privateIp":{"type":"string"}},"required":["role","privateIp"],"additionalProperties":false}},"sshUser":{"type":"string"},"sshPort":{"type":"number"},"extra":{"type":"object","propertyNames":{"type":"string"},"additionalProperties":{}}},"required":["providerId","resources","nodes","sshUser"],"additionalProperties":false},{"type":"object","properties":{"externalId":{"type":"string"},"sshNetworking":{"type":"array","items":{"type":"object","properties":{"host":{"type":"string"},"port":{"type":"number"},"user":{"type":"string"}},"required":["host","port","user"],"additionalProperties":false}},"nodeNetworking":{"type":"array","items":{"type":"object","properties":{"publicIp":{"type":"string"},"privateIp":{"type":"string"}},"required":["publicIp","privateIp"],"additionalProperties":false}},"networkType":{"type":"string","enum":["infiniband","ethernet"]},"gpuFormFactor":{"type":"string","enum":["sxm5","sxm6","pcie"]},"providerId":{"type":"string","const":"mock"},"resources":{"type":"object","properties":{"cpuModel":{"type":"string"},"gpuCount":{"type":"number"},"ramGb":{"type":"number"},"storageGb":{"type":"number"},"vcpuCount":{"type":"number"}},"required":["cpuModel","gpuCount","ramGb","storageGb","vcpuCount"],"additionalProperties":false},"customPorts":{"maxItems":20,"type":"array","items":{"type":"integer","minimum":1,"maximum":65535}}},"required":["providerId","resources"],"additionalProperties":false}],"type":"object"},"name":{"anyOf":[{"type":"string"},{"type":"null"}]},"label":{"anyOf":[{"type":"string"},{"type":"null"}]},"convertToOnDemandOnExpiry":{"anyOf":[{"type":"boolean"},{"type":"null"}]},"managedK8sClusterId":{"anyOf":[{"type":"integer","minimum":-2147483648,"maximum":2147483647},{"type":"null"}]},"meta":{"anyOf":[{"type":"object","properties":{"monitoring_enabled":{"type":"boolean"},"termination_reason":{"type":"string"},"attached_storage":{"type":"array","items":{"type":"object","properties":{"id":{"type":"integer","exclusiveMinimum":0,"maximum":9007199254740991},"cost_per_hour":{"type":"number","exclusiveMinimum":0},"size_in_gb":{"type":"integer","exclusiveMinimum":0,"maximum":9007199254740991},"label":{"type":"string"},"vip":{"type":"string"},"attached_instance_ids":{"type":"array","items":{"type":"number"}}},"required":["id","cost_per_hour","size_in_gb","label","vip","attached_instance_ids"],"additionalProperties":false}},"rental_type":{"type":"string"},"sales_contract_external_id":{"type":"string"}},"additionalProperties":false},{"type":"null"}]},"gpuType":{"type":"string","enum":["h100","h200","b200"]},"gpuCount":{"type":"integer","minimum":-2147483648,"maximum":2147483647},"currentTerm":{"oneOf":[{"type":"object","properties":{"effectiveAt":{"type":"string"},"termType":{"type":"string","const":"on-demand"},"costPerHour":{"type":"number"},"reservedUntil":{"type":"null"},"reservationEndsAt":{"type":"null"},"termPeriodDays":{"type":"null"},"discountPercentage":{"type":"null"},"originalCostPerHour":{"type":"null"}},"required":["effectiveAt","termType","costPerHour","reservedUntil","reservationEndsAt","termPeriodDays","discountPercentage","originalCostPerHour"],"additionalProperties":false},{"type":"object","properties":{"effectiveAt":{"type":"string"},"termType":{"type":"string","const":"reserved"},"costPerHour":{"type":"number"},"reservedUntil":{"anyOf":[{"type":"string"},{"type":"null"}]},"reservationEndsAt":{"anyOf":[{"type":"string"},{"type":"null"}]},"termPeriodDays":{"type":"number"},"discountPercentage":{"type":"number"},"originalCostPerHour":{"type":"number"}},"required":["effectiveAt","termType","costPerHour","reservedUntil","reservationEndsAt","termPeriodDays","discountPercentage","originalCostPerHour"],"additionalProperties":false},{"type":"object","properties":{"effectiveAt":{"type":"string"},"termType":{"type":"string","const":"private-cloud"},"costPerHour":{"type":"number"},"reservedUntil":{"type":"null"},"reservationEndsAt":{"type":"null"},"termPeriodDays":{"type":"null"},"discountPercentage":{"type":"null"},"originalCostPerHour":{"type":"null"}},"required":["effectiveAt","termType","costPerHour","reservedUntil","reservationEndsAt","termPeriodDays","discountPercentage","originalCostPerHour"],"additionalProperties":false}],"type":"object"},"rentalType":{"type":"string","const":"virtual-machine"},"gpuFormFactor":{"type":"string","enum":["sxm5","sxm6","pcie"]},"nodes":{"type":"array","items":{"type":"object","properties":{"cpuModel":{"type":"string"},"gpuCount":{"type":"number"},"ramGb":{"type":"number"},"storageGb":{"type":"number"},"vcpuCount":{"type":"number"}},"required":["cpuModel","gpuCount","ramGb","storageGb","vcpuCount"],"additionalProperties":false}},"connectionType":{"type":"string","enum":["infiniband","ethernet"]},"ethernetVariant":{"type":"string","enum":["normal","rocev2"]},"region":{"type":"string","enum":["us-central-1","us-central-2","eu-north-2","eu-west-2","eu-north-4","eu-north-5","us-east-1","us-east-2","ca-east-3","eu-north-6","eu-north-7","eu-north-8","ca-west-1","ca-east-1","us-central-3","us-southeast-1","me-central-1","ca-east-2","eu-west-1","us-southeast-2","jp-east-1","mock-region","uk-central-3","uk-southeast-3","eu-southwest-3","eu-southwest-3-1","eu-west-3","eu-west-4","private-cloud"]},"createdBy":{"type":"object","properties":{"id":{"type":"string","maxLength":50},"name":{"anyOf":[{"type":"string","maxLength":255},{"type":"null"}]},"email":{"type":"string","maxLength":255},"picture":{"anyOf":[{"type":"string"},{"type":"null"}]}},"required":["id","name","email","picture"],"additionalProperties":false},"supportsFeature":{"type":"object","properties":{"attachedStorage":{"type":"boolean"}},"required":["attachedStorage"],"additionalProperties":false},"status":{"default":"Unknown","type":"string","enum":["Failed","Pending","Running","Terminating","Terminated","Unknown"]},"instances":{"type":"array","items":{"type":"object","properties":{"instanceRef":{"type":"string"},"phase":{"type":"string"},"ssh":{"type":"string"},"internalIp":{"type":"string"},"agentVersion":{"type":"string"},"supportedFeatures":{"type":"array","items":{"type":"string"}}},"required":["instanceRef","phase"],"additionalProperties":false}}},"required":["id","createdAt","updatedAt","deletedAt","userId","orgId","startedAt","terminatedAt","externalId","rentalId","providerData","name","label","convertToOnDemandOnExpiry","managedK8sClusterId","gpuType","gpuCount","currentTerm","rentalType","gpuFormFactor","nodes","connectionType","region","createdBy","supportsFeature","status"],"additionalProperties":false}}}}},"400":{"description":"Invalid input data","content":{"application/json":{"schema":{"$ref":"#/components/schemas/error.BAD_REQUEST"}}}},"401":{"description":"Authorization not provided","content":{"application/json":{"schema":{"$ref":"#/components/schemas/error.UNAUTHORIZED"}}}},"403":{"description":"Insufficient access","content":{"application/json":{"schema":{"$ref":"#/components/schemas/error.FORBIDDEN"}}}},"404":{"description":"Not found","content":{"application/json":{"schema":{"$ref":"#/components/schemas/error.NOT_FOUND"}}}},"500":{"description":"Internal server error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/error.INTERNAL_SERVER_ERROR"}}}}}}},"/v2/alpha/on-demand/rental-history":{"get":{"operationId":"ondemand-getRentalHistory","summary":"Get a list of past rentals","description":"Get a list of past rentals","security":[{"Authorization":[]}],"parameters":[],"responses":{"200":{"description":"Successful response","content":{"application/json":{"schema":{"type":"array","items":{"oneOf":[{"type":"object","properties":{"id":{"type":"integer","minimum":-2147483648,"maximum":2147483647},"createdAt":{"type":"string"},"updatedAt":{"anyOf":[{"type":"string"},{"type":"null"}]},"deletedAt":{"anyOf":[{"type":"string"},{"type":"null"}]},"userId":{"type":"string","maxLength":50},"orgId":{"anyOf":[{},{"type":"null"}]},"startedAt":{"anyOf":[{"type":"string"},{"type":"null"}]},"terminatedAt":{"type":"string"},"externalId":{"type":"string"},"rentalId":{},"providerData":{"oneOf":[{"type":"object","properties":{"externalId":{"type":"string"},"sshNetworking":{"type":"array","items":{"type":"object","properties":{"host":{"type":"string"},"port":{"type":"number"},"user":{"type":"string"}},"required":["host","port","user"],"additionalProperties":false}},"nodeNetworking":{"type":"array","items":{"type":"object","properties":{"publicIp":{"type":"string"},"privateIp":{"type":"string"}},"required":["publicIp","privateIp"],"additionalProperties":false}},"networkType":{"type":"string","enum":["infiniband","ethernet"]},"gpuFormFactor":{"type":"string","enum":["sxm5","sxm6","pcie"]},"providerId":{"type":"string","const":"nebius"},"resources":{"type":"object","properties":{"cpuModel":{"type":"string"},"gpuCount":{"type":"number"},"ramGb":{"type":"number"},"storageGb":{"type":"number"},"vcpuCount":{"type":"number"}},"required":["cpuModel","gpuCount","ramGb","storageGb","vcpuCount"],"additionalProperties":false}},"required":["providerId","resources"],"additionalProperties":false},{"type":"object","properties":{"externalId":{"type":"string"},"sshNetworking":{"type":"array","items":{"type":"object","properties":{"host":{"type":"string"},"port":{"type":"number"},"user":{"type":"string"}},"required":["host","port","user"],"additionalProperties":false}},"nodeNetworking":{"type":"array","items":{"type":"object","properties":{"publicIp":{"type":"string"},"privateIp":{"type":"string"}},"required":["publicIp","privateIp"],"additionalProperties":false}},"networkType":{"type":"string","enum":["infiniband","ethernet"]},"gpuFormFactor":{"type":"string","enum":["sxm5","sxm6","pcie"]},"providerId":{"type":"string","const":"voltage-park"},"resources":{"anyOf":[{"type":"object","properties":{"cpuModel":{"type":"string"},"gpuCount":{"type":"number"},"ramGb":{"type":"number"},"storageGb":{"type":"number"},"cpuCount":{"type":"number"}},"required":["cpuModel","gpuCount","ramGb","storageGb","cpuCount"],"additionalProperties":false},{"type":"object","properties":{"cpuModel":{"type":"string"},"gpuCount":{"type":"number"},"ramGb":{"type":"number"},"storageGb":{"type":"number"},"vcpuCount":{"type":"number"}},"required":["cpuModel","gpuCount","ramGb","storageGb","vcpuCount"],"additionalProperties":false}]},"subOrder":{"type":"string"},"portForwards":{"type":"array","items":{"type":"object","properties":{"externalPort":{"type":"number"},"internalPort":{"type":"number"}},"required":["externalPort","internalPort"],"additionalProperties":false}}},"required":["networkType","providerId","resources"],"additionalProperties":false},{"type":"object","properties":{"externalId":{"type":"string"},"sshNetworking":{"type":"array","items":{"type":"object","properties":{"host":{"type":"string"},"port":{"type":"number"},"user":{"type":"string"}},"required":["host","port","user"],"additionalProperties":false}},"nodeNetworking":{"type":"array","items":{"type":"object","properties":{"publicIp":{"type":"string"},"privateIp":{"type":"string"}},"required":["publicIp","privateIp"],"additionalProperties":false}},"networkType":{"type":"string","enum":["infiniband","ethernet"]},"gpuFormFactor":{"type":"string","enum":["sxm5","sxm6","pcie"]},"providerId":{"type":"string","const":"gcore"},"resources":{"type":"object","properties":{"cpuModel":{"type":"string"},"gpuCount":{"type":"number"},"ramGb":{"type":"number"},"storageGb":{"type":"number"},"cpuCount":{"type":"number"}},"required":["cpuModel","gpuCount","ramGb","storageGb","cpuCount"],"additionalProperties":false}},"required":["providerId","resources"],"additionalProperties":false},{"type":"object","properties":{"externalId":{"type":"string"},"sshNetworking":{"type":"array","items":{"type":"object","properties":{"host":{"type":"string"},"port":{"type":"number"},"user":{"type":"string"}},"required":["host","port","user"],"additionalProperties":false}},"nodeNetworking":{"type":"array","items":{"type":"object","properties":{"publicIp":{"type":"string"},"privateIp":{"type":"string"}},"required":["publicIp","privateIp"],"additionalProperties":false}},"networkType":{"type":"string","enum":["infiniband","ethernet"]},"gpuFormFactor":{"type":"string","enum":["sxm5","sxm6","pcie"]},"providerId":{"type":"string","const":"horizon"},"publicIpAddressId":{"type":"string"},"resources":{"type":"object","properties":{"cpuModel":{"type":"string"},"gpuCount":{"type":"number"},"ramGb":{"type":"number"},"storageGb":{"type":"number"},"vcpuCount":{"type":"number"}},"required":["cpuModel","gpuCount","ramGb","storageGb","vcpuCount"],"additionalProperties":false}},"required":["providerId","resources"],"additionalProperties":false},{"type":"object","properties":{"externalId":{"type":"string"},"sshNetworking":{"type":"array","items":{"type":"object","properties":{"host":{"type":"string"},"port":{"type":"number"},"user":{"type":"string"}},"required":["host","port","user"],"additionalProperties":false}},"nodeNetworking":{"type":"array","items":{"type":"object","properties":{"publicIp":{"type":"string"},"privateIp":{"type":"string"}},"required":["publicIp","privateIp"],"additionalProperties":false}},"networkType":{"type":"string","enum":["infiniband","ethernet"]},"gpuFormFactor":{"type":"string","enum":["sxm5","sxm6","pcie"]},"providerId":{"type":"string","const":"digital-ocean"},"resources":{"type":"object","properties":{"cpuModel":{"type":"string"},"gpuCount":{"type":"number"},"ramGb":{"type":"number"},"storageGb":{"type":"number"},"vcpuCount":{"type":"number"}},"required":["cpuModel","gpuCount","ramGb","storageGb","vcpuCount"],"additionalProperties":false},"poolType":{"anyOf":[{"type":"string","enum":["public","contracted"]},{"type":"null"}]}},"required":["providerId","resources"],"additionalProperties":false},{"type":"object","properties":{"externalId":{"type":"string"},"sshNetworking":{"type":"array","items":{"type":"object","properties":{"host":{"type":"string"},"port":{"type":"number"},"user":{"type":"string"}},"required":["host","port","user"],"additionalProperties":false}},"nodeNetworking":{"type":"array","items":{"type":"object","properties":{"publicIp":{"type":"string"},"privateIp":{"type":"string"}},"required":["publicIp","privateIp"],"additionalProperties":false}},"networkType":{"type":"string","enum":["infiniband","ethernet"]},"gpuFormFactor":{"type":"string","enum":["sxm5","sxm6","pcie"]},"providerId":{"type":"string","const":"verda"},"resources":{"type":"object","properties":{"cpuModel":{"type":"string"},"gpuCount":{"type":"number"},"ramGb":{"type":"number"},"storageGb":{"type":"number"},"vcpuCount":{"type":"number"}},"required":["cpuModel","gpuCount","ramGb","storageGb","vcpuCount"],"additionalProperties":false}},"required":["providerId","resources"],"additionalProperties":false},{"type":"object","properties":{"externalId":{"type":"string"},"sshNetworking":{"type":"array","items":{"type":"object","properties":{"host":{"type":"string"},"port":{"type":"number"},"user":{"type":"string"}},"required":["host","port","user"],"additionalProperties":false}},"nodeNetworking":{"type":"array","items":{"type":"object","properties":{"publicIp":{"type":"string"},"privateIp":{"type":"string"}},"required":["publicIp","privateIp"],"additionalProperties":false}},"networkType":{"type":"string","enum":["infiniband","ethernet"]},"gpuFormFactor":{"type":"string","enum":["sxm5","sxm6","pcie"]},"providerId":{"type":"string","const":"hyperstack"},"resources":{"type":"object","properties":{"cpuModel":{"type":"string"},"gpuCount":{"type":"number"},"ramGb":{"type":"number"},"storageGb":{"type":"number"},"vcpuCount":{"type":"number"}},"required":["cpuModel","gpuCount","ramGb","storageGb","vcpuCount"],"additionalProperties":false}},"required":["providerId","resources"],"additionalProperties":false},{"type":"object","properties":{"externalId":{"type":"string"},"sshNetworking":{"type":"array","items":{"type":"object","properties":{"host":{"type":"string"},"port":{"type":"number"},"user":{"type":"string"}},"required":["host","port","user"],"additionalProperties":false}},"nodeNetworking":{"type":"array","items":{"type":"object","properties":{"publicIp":{"type":"string"},"privateIp":{"type":"string"}},"required":["publicIp","privateIp"],"additionalProperties":false}},"networkType":{"type":"string","enum":["infiniband","ethernet"]},"gpuFormFactor":{"type":"string","enum":["sxm5","sxm6","pcie"]},"providerId":{"type":"string","const":"forge"},"resources":{"anyOf":[{"type":"object","properties":{"cpuModel":{"type":"string"},"gpuCount":{"type":"number"},"ramGb":{"type":"number"},"storageGb":{"type":"number"},"cpuCount":{"type":"number"}},"required":["cpuModel","gpuCount","ramGb","storageGb","cpuCount"],"additionalProperties":false},{"type":"object","properties":{"cpuModel":{"type":"string"},"gpuCount":{"type":"number"},"ramGb":{"type":"number"},"storageGb":{"type":"number"},"vcpuCount":{"type":"number"}},"required":["cpuModel","gpuCount","ramGb","storageGb","vcpuCount"],"additionalProperties":false}]},"customPorts":{"maxItems":20,"type":"array","items":{"type":"integer","minimum":1,"maximum":65535}}},"required":["providerId","resources"],"additionalProperties":false},{"type":"object","properties":{"externalId":{"type":"string"},"sshNetworking":{"type":"array","items":{"type":"object","properties":{"host":{"type":"string"},"port":{"type":"number"},"user":{"type":"string"}},"required":["host","port","user"],"additionalProperties":false}},"nodeNetworking":{"type":"array","items":{"type":"object","properties":{"publicIp":{"type":"string"},"privateIp":{"type":"string"}},"required":["publicIp","privateIp"],"additionalProperties":false}},"networkType":{"type":"string","enum":["infiniband","ethernet"]},"gpuFormFactor":{"type":"string","enum":["sxm5","sxm6","pcie"]},"providerId":{"type":"string","const":"private-cloud"},"gpuModel":{"type":"string"},"location":{"type":"string"},"benchmark":{"type":"object","propertyNames":{"type":"string"},"additionalProperties":{}},"resources":{"anyOf":[{"type":"object","properties":{"cpuModel":{"type":"string"},"gpuCount":{"type":"number"},"ramGb":{"type":"number"},"storageGb":{"type":"number"},"cpuCount":{"type":"number"}},"required":["cpuModel","gpuCount","ramGb","storageGb","cpuCount"],"additionalProperties":false},{"type":"object","properties":{"cpuModel":{"type":"string"},"gpuCount":{"type":"number"},"ramGb":{"type":"number"},"storageGb":{"type":"number"},"vcpuCount":{"type":"number"}},"required":["cpuModel","gpuCount","ramGb","storageGb","vcpuCount"],"additionalProperties":false}]},"nodes":{"type":"array","items":{"type":"object","properties":{"role":{"default":"compute","type":"string","enum":["login","head","compute"]},"hostname":{"type":"string"},"publicIp":{"type":"string"},"privateIp":{"type":"string"}},"required":["role","privateIp"],"additionalProperties":false}},"sshUser":{"type":"string"},"sshPort":{"type":"number"},"extra":{"type":"object","propertyNames":{"type":"string"},"additionalProperties":{}}},"required":["providerId","resources","nodes","sshUser"],"additionalProperties":false},{"type":"object","properties":{"externalId":{"type":"string"},"sshNetworking":{"type":"array","items":{"type":"object","properties":{"host":{"type":"string"},"port":{"type":"number"},"user":{"type":"string"}},"required":["host","port","user"],"additionalProperties":false}},"nodeNetworking":{"type":"array","items":{"type":"object","properties":{"publicIp":{"type":"string"},"privateIp":{"type":"string"}},"required":["publicIp","privateIp"],"additionalProperties":false}},"networkType":{"type":"string","enum":["infiniband","ethernet"]},"gpuFormFactor":{"type":"string","enum":["sxm5","sxm6","pcie"]},"providerId":{"type":"string","const":"mock"},"resources":{"type":"object","properties":{"cpuModel":{"type":"string"},"gpuCount":{"type":"number"},"ramGb":{"type":"number"},"storageGb":{"type":"number"},"vcpuCount":{"type":"number"}},"required":["cpuModel","gpuCount","ramGb","storageGb","vcpuCount"],"additionalProperties":false},"customPorts":{"maxItems":20,"type":"array","items":{"type":"integer","minimum":1,"maximum":65535}}},"required":["providerId","resources"],"additionalProperties":false}],"type":"object"},"name":{"anyOf":[{"type":"string"},{"type":"null"}]},"label":{"anyOf":[{"type":"string"},{"type":"null"}]},"convertToOnDemandOnExpiry":{"anyOf":[{"type":"boolean"},{"type":"null"}]},"managedK8sClusterId":{"anyOf":[{"type":"integer","minimum":-2147483648,"maximum":2147483647},{"type":"null"}]},"meta":{"anyOf":[{"type":"object","properties":{"monitoring_enabled":{"type":"boolean"},"termination_reason":{"type":"string"},"attached_storage":{"type":"array","items":{"type":"object","properties":{"id":{"type":"integer","exclusiveMinimum":0,"maximum":9007199254740991},"cost_per_hour":{"type":"number","exclusiveMinimum":0},"size_in_gb":{"type":"integer","exclusiveMinimum":0,"maximum":9007199254740991},"label":{"type":"string"},"vip":{"type":"string"},"attached_instance_ids":{"type":"array","items":{"type":"number"}}},"required":["id","cost_per_hour","size_in_gb","label","vip","attached_instance_ids"],"additionalProperties":false}},"rental_type":{"type":"string"},"sales_contract_external_id":{"type":"string"}},"additionalProperties":false},{"type":"null"}]},"gpuType":{"type":"string","enum":["h100","h200","b200"]},"gpuCount":{"type":"integer","minimum":-2147483648,"maximum":2147483647},"currentTerm":{"oneOf":[{"type":"object","properties":{"effectiveAt":{"type":"string"},"termType":{"type":"string","const":"on-demand"},"costPerHour":{"type":"number"},"reservedUntil":{"type":"null"},"reservationEndsAt":{"type":"null"},"termPeriodDays":{"type":"null"},"discountPercentage":{"type":"null"},"originalCostPerHour":{"type":"null"}},"required":["effectiveAt","termType","costPerHour","reservedUntil","reservationEndsAt","termPeriodDays","discountPercentage","originalCostPerHour"],"additionalProperties":false},{"type":"object","properties":{"effectiveAt":{"type":"string"},"termType":{"type":"string","const":"reserved"},"costPerHour":{"type":"number"},"reservedUntil":{"anyOf":[{"type":"string"},{"type":"null"}]},"reservationEndsAt":{"anyOf":[{"type":"string"},{"type":"null"}]},"termPeriodDays":{"type":"number"},"discountPercentage":{"type":"number"},"originalCostPerHour":{"type":"number"}},"required":["effectiveAt","termType","costPerHour","reservedUntil","reservationEndsAt","termPeriodDays","discountPercentage","originalCostPerHour"],"additionalProperties":false},{"type":"object","properties":{"effectiveAt":{"type":"string"},"termType":{"type":"string","const":"private-cloud"},"costPerHour":{"type":"number"},"reservedUntil":{"type":"null"},"reservationEndsAt":{"type":"null"},"termPeriodDays":{"type":"null"},"discountPercentage":{"type":"null"},"originalCostPerHour":{"type":"null"}},"required":["effectiveAt","termType","costPerHour","reservedUntil","reservationEndsAt","termPeriodDays","discountPercentage","originalCostPerHour"],"additionalProperties":false}],"type":"object"},"rentalType":{"type":"string","const":"virtual-machine"},"gpuFormFactor":{"type":"string","enum":["sxm5","sxm6","pcie"]},"nodes":{"type":"array","items":{"type":"object","properties":{"cpuModel":{"type":"string"},"gpuCount":{"type":"number"},"ramGb":{"type":"number"},"storageGb":{"type":"number"},"vcpuCount":{"type":"number"}},"required":["cpuModel","gpuCount","ramGb","storageGb","vcpuCount"],"additionalProperties":false}},"connectionType":{"type":"string","enum":["infiniband","ethernet"]},"ethernetVariant":{"type":"string","enum":["normal","rocev2"]},"region":{"type":"string","enum":["us-central-1","us-central-2","eu-north-2","eu-west-2","eu-north-4","eu-north-5","us-east-1","us-east-2","ca-east-3","eu-north-6","eu-north-7","eu-north-8","ca-west-1","ca-east-1","us-central-3","us-southeast-1","me-central-1","ca-east-2","eu-west-1","us-southeast-2","jp-east-1","mock-region","uk-central-3","uk-southeast-3","eu-southwest-3","eu-southwest-3-1","eu-west-3","eu-west-4","private-cloud"]},"createdBy":{"type":"object","properties":{"id":{"type":"string","maxLength":50},"name":{"anyOf":[{"type":"string","maxLength":255},{"type":"null"}]},"email":{"type":"string","maxLength":255},"picture":{"anyOf":[{"type":"string"},{"type":"null"}]}},"required":["id","name","email","picture"],"additionalProperties":false},"supportsFeature":{"type":"object","properties":{"attachedStorage":{"type":"boolean"}},"required":["attachedStorage"],"additionalProperties":false},"status":{"type":"string","enum":["Terminated","Failed"]},"totalCost":{"type":"number"}},"required":["id","createdAt","updatedAt","deletedAt","userId","orgId","startedAt","terminatedAt","externalId","rentalId","providerData","name","label","convertToOnDemandOnExpiry","managedK8sClusterId","gpuType","gpuCount","currentTerm","rentalType","gpuFormFactor","nodes","connectionType","region","createdBy","supportsFeature","status","totalCost"],"additionalProperties":false},{"type":"object","properties":{"id":{"type":"integer","minimum":-2147483648,"maximum":2147483647},"createdAt":{"type":"string"},"updatedAt":{"anyOf":[{"type":"string"},{"type":"null"}]},"deletedAt":{"anyOf":[{"type":"string"},{"type":"null"}]},"userId":{"type":"string","maxLength":50},"orgId":{"anyOf":[{},{"type":"null"}]},"startedAt":{"anyOf":[{"type":"string"},{"type":"null"}]},"terminatedAt":{"type":"string"},"externalId":{"type":"string"},"rentalId":{},"providerData":{"oneOf":[{"type":"object","properties":{"externalId":{"type":"string"},"sshNetworking":{"type":"array","items":{"type":"object","properties":{"host":{"type":"string"},"port":{"type":"number"},"user":{"type":"string"}},"required":["host","port","user"],"additionalProperties":false}},"nodeNetworking":{"type":"array","items":{"type":"object","properties":{"publicIp":{"type":"string"},"privateIp":{"type":"string"}},"required":["publicIp","privateIp"],"additionalProperties":false}},"networkType":{"type":"string","enum":["infiniband","ethernet"]},"gpuFormFactor":{"type":"string","enum":["sxm5","sxm6","pcie"]},"providerId":{"type":"string","const":"nebius"},"resources":{"type":"object","properties":{"cpuModel":{"type":"string"},"gpuCount":{"type":"number"},"ramGb":{"type":"number"},"storageGb":{"type":"number"},"vcpuCount":{
[...]
